;; FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS
;; FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS
;; FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS   FINITELY-GENERATED-GROUPS

(IN-PACKAGE "COMMON-LISP-USER")

(provide "finitely-generated-groups")


;;;;;;;;;;;;;;;;;;;;;
;;;;; clases y tipos
;;;;;;;;;;;;;;;;;;;;;

(DEFCLASS FNGN-ABGROUP ()
  ((mtrx :type matrice :initarg :mtrx :reader mtrx)
   (idnm :type fixnum :initform (incf *idnm-counter*) :reader idnm)
   (orgn :type list :initarg :orgn :reader orgn)
   ))


(DEFMETHOD INITIALIZE-INSTANCE :after ((FNGN-ABGROUP FNGN-ABGROUP) &rest rest)
  (set (intern (format nil "K~D" (idnm FNGN-ABGROUP))) FNGN-ABGROUP))

(DEFCLASS FNGN-ABGROUP-MRPH ()
    ;; SOuRCe     
    ((sorc :type fngr-abgroup :initarg :sorc :reader sorc)
     ;; TaRGeT 
     (trgt :type fngr-abgroup :initarg :trgt :reader trgt)
     ;; MaTRiX0      
     (mtrx0 :type matrice :initarg :mtrx0 :reader mtrx0) 
     ;; MaTRiX1      
     (mtrx1 :type matrice :initarg :mtrx1 :reader mtrx1)    
     ;; IDentification NuMber      
     (idnm :type fixnum :initform (incf *idnm-counter*) :reader idnm)      
     ;; ORiGiN      
     (orgn :type list :initarg :orgn :reader orgn)))


(DEFMETHOD INITIALIZE-INSTANCE :after ((FNGN-ABGROUP-MRPH FNGN-ABGROUP-MRPH) &rest rest)
  (set (intern (format nil "K~D" (idnm FNGN-ABGROUP-MRPH))) FNGN-ABGROUP-MRPH))

(DEFVAR *fngn-abgroup-list*)
(SETF *fngn-abgroup-list* +empty-list+)
(PUSHNEW '*fngn-abgroup-list* *list-list*)


(DEFVAR *fngn-abgroup-mrph-list*)
(SETF *fngn-abgroup-mrph-list* +empty-list+)
(PUSHNEW '*fngn-abgroup-mrph-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((fngn-abgroup fngn-abgroup) stream)
   (the fngn-abgroup
     (progn
      (format stream "[K~D Fngn-abgroup]" (idnm fngn-abgroup))
      fngn-abgroup)))


(DEFMETHOD PRINT-OBJECT ((fngn-abgroup-mrph fngn-abgroup-mrph) stream)
   (the fngn-abgroup-mrph
     (progn
      (format stream "[K~D Fngn-abgroup-mrph]" (idnm fngn-abgroup-mrph))
       fngn-abgroup-mrph)))



(DEFUN FNGN-ABGROUP (idnm)
   (declare (type fixnum idnm))
   (the (or FNGN-ABGROUP null)
     (find idnm *fngn-abgroup-list* :key #'idnm)))


(DEFUN FNGN-ABGROUP-MRPH (idnm)
   (declare (type fixnum idnm))
   (the (or FNGN-ABGROUP-MRPH null)
     (find idnm *fngn-abgroup-mrph-list* :key #'idnm)))

(defun build-fngn-abgroup (&key mtrx divs orgn)
   (declare 
     (type matrice mtrx)
     (list divs orgn))
  (the fngn-abgroup
      (let* ((m
              (if (not mtrx)
                  (let* ((nlig (length divs))
                         (ncol 
                          (if (position 0 divs)
                              (position 0 divs)
                            (length divs)))
                         (mtrx (creer-matrice nlig ncol)))
                    (dotimes (i ncol)
                      (inserer-terme (baselig mtrx (1+ i)) (basecol mtrx (1+ i)) (nth i divs))                  
                      )
                    mtrx)
                mtrx))
              (orgn (if (not orgn)
                        `(Fngn-abgroup ,m)
                      orgn))
              
              )
              (progn
         (let ((already (find orgn *fngn-abgroup-list* :test #'equal :key #'orgn)))
         (declare (type (or fngn-abgroup null) already))
         (when already
           (return-from build-fngn-abgroup already)))
         (let ((group (make-instance 'fngn-abgroup
                        :mtrx m
                        :orgn orgn)))
           (declare (type fngn-abgroup group))   
           (push group *fngn-abgroup-list*)
           group)))))




(defun cyclic-group (p)
  (declare (type fixnum p))
  (if (> p 0)
      (let ((gm (creer-matrice 1 1)))
        (inserer-terme (baselig gm 1) (basecol gm 1) p)
        (build-fngn-abgroup :mtrx gm :orgn `(Cyclic group of order ,p)))
    (let ((gm (creer-matrice 1 0)))
      (build-fngn-abgroup :mtrx gm :orgn `(Infinite cyclic group)))))


(defun trivial-group ()
  (let ((gm (creer-matrice 0 0)))
    (build-fngn-abgroup :mtrx gm :orgn `(Trivial group)))
    )



(defun build-mtrx (&key nrow ncol entries)
  (declare
   (fixnum nrow ncol)
   (list entries))
  (let ((m (creer-matrice nrow ncol))
        (k 0))
    (dotimes (i nrow)
      (dotimes (j ncol)
        (if (not (eq 0 (nth k entries)))
            (inserer-terme (baselig m (1+ i)) (basecol m (1+ j)) (nth k entries)))
        (setf k (1+ k))))
    m))
      

  



(DEFUN BUILD-fngn-abgroup-mrph (&key sorc trgt mtrx0 mtrx1 orgn)
   (declare
      (type fngn-abgroup sorc trgt)
      (type matrice mtrx0 mtrx1)
      (list orgn))
   (the fngn-abgroup-mrph
     (let ((orgn (if (not orgn)
                     `(Fngn-abgroup-mrph ,sorc ,trgt ,mtrx0 ,mtrx1)
                   orgn)))
       (progn
       (let ((already (find orgn *fngn-abgroup-mrph-list* :test #'equal :key #'orgn)))
         (declare (type (or fngn-abgroup-mrph null) already))
         (when already
           (return-from build-fngn-abgroup-mrph already)))
       (let ((mrph (make-instance 'fngn-abgroup-mrph
                     :sorc sorc 
                     :trgt trgt 
                     :mtrx0 mtrx0
                     :mtrx1 mtrx1
                     :orgn orgn)))
         (declare (type fngn-abgroup-mrph mrph))
         (push mrph *fngn-abgroup-mrph-list*)
            mrph)))))


(defun matrices-eq (mtrx1 mtrx2)
  (declare (type matrice mtrx1 mtrx2))
  (if (not (and (eq (nlig mtrx1) (nlig mtrx2)) (eq (ncol mtrx1) (ncol mtrx2)))) nil
    (let ((rslt 't))
      (dotimes (i (nlig mtrx1))
          (dotimes (j (ncol mtrx1))
              (if (not (eq (extract-term mtrx1 (1+ i) (1+ j)) (extract-term mtrx2 (1+ i) (1+ j))))
                  (setf rslt nil))))
      rslt)))


(defun mtrx-op (mtrx)
  (declare (type matrice mtrx))
   (the matrice
     (let* ((line-n (line-number mtrx))
            (column-n (column-number mtrx))
            )
        (declare (type fixnum line-n column-n))
          (let ((mat (creer-matrice line-n column-n))
                (res nil))
            (declare (type list res))
            (dotimes (il line-n)
              (mapcar #'(lambda (pair)
                          (let ((ic (first pair)))
                            (push (list (1+ il) (list (list ic (- (second pair))))) res)))
              (extract-line mtrx (1+ il)))
              ) 
             
                
            (maj-matrice mat res)))))




(defun mtrx-conc2 (mtrx1 mtrx2)
   (declare (type matrice mtrx1 mtrx2))
   (the matrice
     (let* ((line-n-1 (line-number mtrx1))
            (column-n-1 (column-number mtrx1))
            (line-n-2 (line-number mtrx2))
            (column-n-2 (column-number mtrx2))
            (line-n (+ line-n-1 line-n-2))
            (column-n (max column-n-1 column-n-2)))
        (declare (type fixnum line-n-1 column-n-1 line-n-2
                   column-n-2 line-n column-n))
          (let ((mat (creer-matrice line-n column-n))
                (res nil))
            (declare (type list res))
            (dotimes (il line-n-1)
              (mapcar #'(lambda (pair)
                          (let ((ic (first pair)))
                            (push (list (1+ il) (list (list ic (second pair)))) res)))
              (extract-line mtrx1 (1+ il)))
              ) 
            (dotimes (il line-n-2)
              (mapcar #'(lambda (pair)
                          (let ((ic (first pair)))     
                            (push (list (1+ (+ line-n-1 il)) (list (list ic (second pair)))) res)))
              (extract-line mtrx2 (1+ il)))
            ) 
                
            (maj-matrice mat res)))))






#|
(setf m1 (random-matrix 4 2 .4 4))
(setf m2 (random-matrix 6 3 .4 4))
(mtrx-op m1)
(mtrx-conc2 m1 m2)

|#


            

(defun check-fngn-abgroup (group)
  (let* ((mtrx (mtrx group))
         (cn-mtrx (first (canonical-representation mtrx))))
    (matrices-eq mtrx cn-mtrx)))


#|
(setf m (random-matrix 4 2 .4 4))
(setf gr (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(check-fngn-abgroup gr)

(setf m2 (creer-matrice 4 2))
(inserer-terme (baselig m2 1) (basecol m2 1) 2)
(inserer-terme (baselig m2 2) (basecol m2 2) 4)
(setf gr2 (build-fngn-abgroup :mtrx m2 :orgn   `(group ,m2)))
(check-fngn-abgroup gr2)

(setf m2 (creer-matrice 4 2))
(inserer-terme (baselig m2 1) (basecol m2 1) 4)
(inserer-terme (baselig m2 2) (basecol m2 2) 2)
(setf gr2 (build-fngn-abgroup :mtrx m2 :orgn   `(group ,m2)))
(check-fngn-abgroup gr2)
|#

 
(defun check-fngn-abgroup-mrph (mrph)
  (let* ((sorc (sorc mrph))
         (trgt (trgt mrph))
         (mtrx0 (mtrx0 mrph))
         (mtrx1 (mtrx1 mrph))
         (prdc1 (mtrx-prdc  (mtrx trgt) mtrx1))
         (prdc2 (mtrx-prdc mtrx0 (mtrx sorc))))
    (and (check-fngn-abgroup sorc)
         (check-fngn-abgroup trgt)
         (matrices-eq prdc1 prdc2))))


#|

(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(check-fngn-abgroup-mrph mrph)
|#

(defun mrph-cmps (mrph1 mrph2)
  (let* ((sorc (sorc mrph1))
         (trgt (trgt mrph2))
         (mtrx0 (mtrx-prdc (mtrx0 mrph2) (mtrx0 mrph1)))
         (mtrx1 (mtrx-prdc (mtrx1 mrph2) (mtrx1 mrph1))))
    (the fngn-abgroup-mrph
      (build-fngn-abgroup-mrph :sorc sorc :trgt trgt :mtrx0 mtrx0 :mtrx1 mtrx1 :orgn `(Composition of morphisms ,mrph1 and ,mrph2)))))

(defun mrph-zerop (mrph)
  (let* ((mtrx0 (mtrx0 mrph))
         (d (mtrx (trgt mrph)))
         (rslt 't))
    (dotimes (i (nlig mtrx0))
      (dotimes (j (ncol mtrx0))
        (let ((mij (extract-term mtrx0 (1+ i) (1+ j))))
          (if (< i (ncol d))
              (let ((dii (extract-term d (1+ i) (1+ i))))
                (if (not (eq 0 (mod mij dii))) (setf rslt nil)))
            (if (not (eq 0 mij)) (setf rslt nil))))))
    rslt))



      
          

    
            
        
 #|
(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf mrph1 (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(setf mrph2 (build-fngn-abgroup-mrph :sorc gr2 :trgt gr1 :mtrx0 m1 :mtrx1 m0 :orgn '(group-morphism)))
(setf cm (mrph-cmps mrph1 mrph2))
(mrph-zerop cm)

(setf cm2 (mrph-cmps mrph2 mrph1))
(mrph-zerop cm2)


(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf mrph1 (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(setf mrph2 (build-fngn-abgroup-mrph :sorc gr2 :trgt gr1 :mtrx0 m1 :mtrx1 m0 :orgn '(group-morphism)))
(setf cm (mrph-cmps mrph1 mrph2))
(mrph-zerop cm)

(setf cm2 (mrph-cmps mrph2 mrph1))
(mrph-zerop cm2)



|#

 

(defun mrph-element-preimage (mrph c)
  (let* ((mtrx (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
         (smith (smith mtrx))
         (p (first smith))
         (p-1 (second smith))
         (d (third smith))
         (q (fourth smith))
         (q-1 (fifth smith))
         (pc (column-j  (mtrx-prdc p (Gnrt-List-to-Mtrx (list c))) 1))
         (pc-1 nil))
    (if (not c)
        (zero-list (ncol (mtrx0 mrph)))
      (progn
        (dotimes (i (length pc))
          (let ((pci (nth i pc))
                (di (extract-term d (1+ i) (1+ i))))
            (if (eq 0 pci) (push pci pc-1)
              (push (/ pci di) pc-1 ))))
        (subseq (column-j (mtrx-prdc q-1 (Gnrt-List-to-Mtrx 
                                          (list (nconc pc-1 (zero-list (- (ncol mtrx) (length c))))))) 1) 
                0 (ncol (mtrx0 mrph)))))))


#|

(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 3)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 6)
(setf m0 (creer-matrice 1 1))
(setf m1 (creer-matrice 1 1))
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z3)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z6)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism4)))
(setf c '(0))
(mrph-element-preimage mrph c)




(setf gm1 (creer-matrice 2 2))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 3)
(inserer-terme (baselig gm1 2) (basecol gm1 2) 3)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 6)
(setf m0 (creer-matrice 1 2))
(setf m1 (creer-matrice 1 2))
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z3+z3)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z6)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism5)))
(setf c '(0))
(mrph-element-preimage mrph c)


(setf mtrx (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
(setf smith (smith mtrx))
(setf p (first smith))
(setf p-1 (second smith))
(setf d (third smith))
(setf q (fourth smith))
(setf q-1 (fifth smith))
(setf pc (column-j  (mtrx-prdc p (Gnrt-List-to-Mtrx (list c))) 1))
(setf pc-1 nil)
(dotimes (i (length pc))
      (let ((pci (nth i pc))
            (di (extract-term d (1+ i) (1+ i))))
        (if (eq 0 pci) (push pci pc-1)
          (push (/ pci di) pc-1 ))))
(subseq (column-j (mtrx-prdc q-1 (Gnrt-List-to-Mtrx 
                                  (list (nconc pc-1 (zero-list (ncol (mtrx (trgt mrph)))))))) 1) 
        0 (ncol (mtrx0 mrph)))




|#




(defun divisors (group)
  (declare (type FNGN-ABGROUP group))
  (let ((mtrx (mtrx group)))
    (dotimes (i (nlig mtrx))
      (progn 
        (format t "~2%Component Z")
        (if (< i (ncol mtrx))
            (format t "/~DZ" (EXTRACT-TERM mtrx (1+ i) (1+ i))))))))



(defun divisors-list (group)
  (declare (type FNGN-ABGROUP group))
  (let* ((mtrx (mtrx group))
        (rslt (zero-list (- (nlig mtrx) (ncol mtrx)))))
    (dotimes (i (ncol mtrx))
      (let ((j (- (ncol mtrx) i)))
        (push (EXTRACT-TERM mtrx j j) rslt)))
    rslt))



(defun cmbn-zerop (group cmbn)
  (let ((div (divisors-list group))
        (rslt 't))
    (dotimes (i (length div))
      (let ((di (nth i div)))
        (if (= 0 di)
            (if (not (= 0 (nth i cmbn)))
                (setf rslt nil))
          (if (not (eq 0 (mod (nth i cmbn) (nth i div)))) 
              (setf rslt nil)))))
    rslt))

    
#|
(setf m (random-matrix 4 2 .4 4))
(setf gr (build-fngn-abgroup :mtrx (first (canonical-representation m)) :orgn   `(group ,m)))
(third (smith (copy-mtrx m)))
(check-fngn-abgroup gr)
(mtrx gr)
(divisors gr)

(setf m2 (creer-matrice 4 2))
(inserer-terme (baselig m2 1) (basecol m2 1) 2)
(inserer-terme (baselig m2 2) (basecol m2 2) 4)
(setf gr2 (build-fngn-abgroup :mtrx m2 :orgn   `(group ,m2)))
(check-fngn-abgroup gr2)

(setf m2 (creer-matrice 4 2))
(inserer-terme (baselig m2 1) (basecol m2 1) 4)
(inserer-terme (baselig m2 2) (basecol m2 2) 2)
(setf gr2 (build-fngn-abgroup :mtrx m2 :orgn   `(group ,m2)))
(check-fngn-abgroup gr2)
|#
    


(defun canonical-representation (mtrx)
  (declare (type matrice mtrx))
  (let* ((smith (smith (copy-mtrx mtrx)))
         (p (first smith))
         (p-1 (second smith))
         (d (third smith))
         (i 0)
         (j 0)
         (min (min (nlig d) (ncol d)))
         )
    (dotimes (k min)
      (let ((akk (EXTRACT-TERM d (1+ k) (1+ k))))
        (if (eql 1 akk)
            (progn
              (setf i (1+ i))
              (setf j (1+ j)))
          (if (not (eql 0 akk))
            (setf j (1+ j))
            ))))
    (let ((first-line (1+ i))
          (last-line (nlig d))
          (first-col (1+ i))
          (last-col j))
      (list 
      (if (> first-col last-col)
       (creer-matrice (1+ (- last-line first-line)) 0)    
        (SUBMATRIX d first-line last-line first-col last-col))
       (if (> first-line last-line)
           (creer-matrice (ncol p) 0 )
         (submatrix p 1 last-line first-col (ncol p))
         )
       (if (> first-col last-col)
           (creer-matrice  0 (ncol p) )
         (submatrix p-1  first-col (ncol p) 1 last-line)
                  )))))




        
 #|       
;;(setf m (random-matrix 4 4 .4 10))
(setf d (third (smith (copy-mtrx m))))
(setf cm (first (canonical-representation m)))
(setf p1 (first (smith (copy-mtrx m))))
(setf p1-1 (second (smith (copy-mtrx m))))
(setf q1 (fourth (smith (copy-mtrx m))))
(setf q1-1 (fifth (smith (copy-mtrx m))))
(mtrx-prdc p1-1 (mtrx-prdc m  q1))


(setf p (second (canonical-representation m)))


(mtrx-prdc p cm)
(setf gr (build-fngn-abgroup :mtrx cm :orgn `(group ,cm)))
(divisors gr)

(setf m2 (creer-matrice 2 3))
(inserer-terme (baselig m2 1) (basecol m2 1) 1)
(inserer-terme (baselig m2 2) (basecol m2 1) 2)
(inserer-terme (baselig m2 2) (basecol m2 2) 4)
m2
(smith (copy-mtrx m2))

(setf m3 (creer-matrice 3 2))
(inserer-terme (baselig m3 1) (basecol m3 1) 1)
(inserer-terme (baselig m3 2) (basecol m3 1) 2)
(inserer-terme (baselig m3 2) (basecol m3 2) 4)
m3
(smith (copy-mtrx m3))


|#



(defun cokernel3 (mrph)
  (declare (type FNGN-ABGROUP-MRPH mrph))
  (let* ((aux (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
         (aux2 (canonical-representation aux))
         (mtrx (first aux2))
         (inc (second aux2))
         (proj (third aux2)))
    (list 
     (the fngn-abgroup
       (build-fngn-abgroup :mtrx mtrx :orgn `(Cokernel of morphism ,mrph)))
      
     proj inc)
    ))


(defun cokernel-element-preimage (mrph c)
  (let* ((aux (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
         (aux2 (canonical-representation aux))
         (inc (second aux2))
         )
    (column-j  (mtrx-prdc inc (Gnrt-List-to-Mtrx (list c))) 1)
    ))



#|
(defun cokernel (mrph)
  (declare (type FNGN-ABGROUP-MRPH mrph))
  (let* ((aux (mtrx-conc (mtrx0 mrph) (mtrx (trgt mrph))))
         (smith (smith (copy-mtrx aux)))
         (p-1 (second smith))
         (d (third smith))
         (i 0)
         (j 0)
         (min (min (nlig d) (ncol d)))
         )
    (dotimes (k min)
      (let ((akk (EXTRACT-TERM d (1+ k) (1+ k))))
        (if (eql 1 akk)
            (progn
              (setf i (1+ i))
              (setf j (1+ j)))
          (if (not (eql 0 akk))
            (setf j (1+ j))
            ))))
    (let* ((first-line (1+ i))
          (last-line (nlig d))
          (first-col (1+ i))
          (last-col j)
          (mtrx 
           (if (> first-col last-col)
               (creer-matrice (1+ (- last-line first-line)) 0) 
             (SUBMATRIX d first-line last-line first-col last-col)))
          (proj 
           (if (> first-col last-col)
               (creer-matrice 0 (nlig d) )
             (submatrix p-1 first-line last-line 1 (nlig d)))))
      (list 
       (the fngn-abgroup
         (build-fngn-abgroup :mtrx mtrx :orgn `(Cokernel of morphism ,mrph)))
       proj)
    )))
|#



#|
(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(setf ck (cokernel mrph))
(divisors (first ck))

|#



(defun kernel3 (mrph)
  (declare (type FNGN-ABGROUP-MRPH mrph))
  (let* ((dffr1 (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
         (dffr2 (mtrx-conc2 (mtrx (sorc mrph)) (mtrx1 mrph)))
         (n (ncol (mtrx0 mrph)))
         (smith-list-1 (smith dffr1))
         (q1 (fourth smith-list-1))
         (q1-1 (fifth smith-list-1))
         (d1 (third smith-list-1))
         (q1-1Xdffr2 (mtrx-prdc q1-1 dffr2))
         (i 1))
    (while (and (<= i (nlig d1)) (not (eq (extract-term d1 i i) 0)))
      (setf i (1+ i)))
    (if (> i (nlig dffr2))
        (let ((inc (creer-matrice  (nlig d1) 0)))
          (list 
           (the fngn-abgroup
             (trivial-group))
           inc))
      (if (= 0 (ncol dffr2))
          (let ((q1 (submatrix q1 1 (nlig q1) i (ncol q1)))
                (mtrx (creer-matrice  (1+ (- (ncol d1) i)) 0)))
          (list 
           (the fngn-abgroup
             (build-fngn-abgroup :mtrx mtrx :orgn `(Kernel of morphism ,mrph)))
           q1))
        (let*  
            ((q1 (submatrix q1 1 (nlig q1) i (ncol q1)))
             (q1-1 (submatrix q1-1 i (nlig q1) 1 (ncol q1)))
             (aux1 (submatrix q1-1Xdffr2 i (nlig q1-1Xdffr2) 1 (ncol q1-1Xdffr2)))
             (aux2 (canonical-representation aux1))
             (mtrx (first aux2))
             (aux3 (mtrx-prdc q1 (second aux2)))
             (aux4 (mtrx-prdc (third aux2) q1-1))
             (inc 
              (if (>= (ncol aux3) 1)
                  (submatrix aux3 1 n 1 (ncol aux3))
                (creer-matrice n 0)
                ))
             (proj 
              (if (>= (nlig aux4) 1)
                  (submatrix aux4 1 (nlig aux4) 1 n )
                (creer-matrice 0 n)
                
             ))
        )
          (list 
           (the fngn-abgroup
             (build-fngn-abgroup :mtrx mtrx :orgn `(Kernel of morphism ,mrph)))
           inc proj
           ))))))



(defun kernel-element-image (mrph c)
  (if (eq 0 (ncol (mtrx0 mrph))) nil
  (let ((mc (column-j (mtrx-prdc (mtrx0 mrph) (Gnrt-List-to-Mtrx (list c))) 1))
        (mc-1 nil))
    (dotimes (i (length mc))
      (let ((mci (nth i mc))
            (di (extract-term (mtrx (trgt mrph)) (1+ i) (1+ i))))
        (if (eq 0 mci) (push mci mc-1)
          (push (- (/ mci di)) mc-1 ))))
    (setf mc-1 (nreverse mc-1))
    (let* ((c+mc-1 (nconc c mc-1))
           (dffr1 (mtrx-conc (mtrx0 mrph) (mtrx-op (mtrx (trgt mrph)))))
           (dffr2 (mtrx-conc2 (mtrx (sorc mrph)) (mtrx1 mrph)))
           (n (ncol (mtrx0 mrph)))
           (smith-list-1 (smith dffr1))
           (q1 (fourth smith-list-1))
           (q1-1 (fifth smith-list-1))
           (d1 (third smith-list-1))
           (q1-1Xdffr2 (mtrx-prdc q1-1 dffr2))
           (i 1)
           )
      (while (and (<= i (nlig d1)) (not (eq (extract-term d1 i i) 0)))
        (setf i (1+ i)))
      (if (> i (nlig dffr2))
          (let ((inc (creer-matrice  (nlig d1) 0)))
            (list 
             (the fngn-abgroup
               (trivial-group))
             inc))
        (if (= 0 (ncol dffr2))
            (let ((q1 (submatrix q1 1 (nlig q1) i (ncol q1)))
                  (mtrx (creer-matrice  (1+ (- (nlig d1) i)) 0)))
              (list 
               (the fngn-abgroup
                 (build-fngn-abgroup :mtrx mtrx :orgn `(Kernel of morphism ,mrph)))
               q1))
          (let*  
              ((q1-2 (submatrix q1 1 (nlig q1) i (ncol q1)))
               (q1-1-2 (submatrix q1-1 i (nlig q1) 1 (ncol q1)))
               (aux1 (submatrix q1-1Xdffr2 i (nlig q1-1Xdffr2) 1 (ncol q1-1Xdffr2)))
               (aux2 (canonical-representation aux1))
               (mtrx (first aux2))
               (aux3 (mtrx-prdc q1-2 (second aux2)))
               (aux4 (mtrx-prdc (third aux2) q1-1-2))
               
               )
            (column-j  (mtrx-prdc aux4 (Gnrt-List-to-Mtrx (list c+mc-1))) 1)
                         
            )))))))


(DEFGENERIC mrph-kernel (arg1))

(DEFGENERIC mrph-cokernel (arg1))

(defmethod mrph-kernel ((mrph FNGN-ABGROUP-MRPH))
  (kernel3 mrph))

(defmethod mrph-cokernel ((mrph FNGN-ABGROUP-MRPH))
  (cokernel3 mrph))


#|
(cat-init)
(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(setf kr (kernel2 mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))



(cat-init)
(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 4)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 2)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 1)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 2)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z4)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z2)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))
(setf kr (kernel2 mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))
(kernel-element-image mrph '(2))


(cat-init)
(setf gm1 (creer-matrice 3 2))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(inserer-terme (baselig gm1 2) (basecol gm1 2) 4)
(setf gm2 (creer-matrice 2 2))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 2)
(inserer-terme (baselig gm2 2) (basecol gm2 2) 4)

(setf m0 (creer-matrice 2 3))
(inserer-terme (baselig m0 1) (basecol m0 2) 1)
(inserer-terme (baselig m0 2) (basecol m0 1) 2)
(inserer-terme (baselig m0 2) (basecol m0 2) 2)
(inserer-terme (baselig m0 2) (basecol m0 3) 1)

(setf m1 (creer-matrice 2 2))
(inserer-terme (baselig m1 1) (basecol m1 2) 2)
(inserer-terme (baselig m1 2) (basecol m1 1) 1)
(inserer-terme (baselig m1 2) (basecol m1 2) 2)

(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2+z4+z)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z2+z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))

(check-fngn-abgroup gr1)
(check-fngn-abgroup gr2)
(check-fngn-abgroup-mrph mrph)





(setf kr (kernel mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))
(kernel-element-image mrph '(0 2 0))
(kernel-element-image mrph '(1 0 -2))
(kernel-element-image mrph '(-1 2 -2))



(cat-init)
(setf gm1 (creer-matrice 3 2))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(inserer-terme (baselig gm1 2) (basecol gm1 2) 4)
(setf gm2 (creer-matrice 2 2))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 2)
(inserer-terme (baselig gm2 2) (basecol gm2 2) 4)

(setf m0 (creer-matrice 2 3))
(inserer-terme (baselig m0 1) (basecol m0 2) 1)
(inserer-terme (baselig m0 2) (basecol m0 1) 2)
(inserer-terme (baselig m0 2) (basecol m0 2) 2)
(inserer-terme (baselig m0 2) (basecol m0 3) 2)

(setf m1 (creer-matrice 2 2))
(inserer-terme (baselig m1 1) (basecol m1 2) 2)
(inserer-terme (baselig m1 2) (basecol m1 1) 1)
(inserer-terme (baselig m1 2) (basecol m1 2) 2)

(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2+z4+z)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z2+z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))

(check-fngn-abgroup gr1)
(check-fngn-abgroup gr2)
(check-fngn-abgroup-mrph mrph)





(setf kr (kernel mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))
(kernel-element-image mrph '(0 2 0))
(kernel-element-image mrph '(1 0 -2))
(kernel-element-image mrph '(-1 2 -2))




(cat-init)
(setf gm1 (creer-matrice 3 2))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(inserer-terme (baselig gm1 2) (basecol gm1 2) 4)
(setf gm2 (creer-matrice 2 2))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 2)
(inserer-terme (baselig gm2 2) (basecol gm2 2) 4)

(setf m0 (creer-matrice 2 3))
(inserer-terme (baselig m0 2) (basecol m0 1) 2)


(setf m1 (creer-matrice 2 2))
(inserer-terme (baselig m1 2) (basecol m1 1) 1)

(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2+z4+z)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z2+z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))

(check-fngn-abgroup gr1)
(check-fngn-abgroup gr2)
(check-fngn-abgroup-mrph mrph)





(setf kr (kernel mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))

(kernel-element-image mrph '(0 1 0))
(kernel-element-image mrph '(0 0 1))
(kernel-element-image mrph '(0 2 3))







(cat-init)
(setf gm1 (creer-matrice 3 2))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(inserer-terme (baselig gm1 2) (basecol gm1 2) 4)
(setf gm2 (creer-matrice 2 2))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 2)
(inserer-terme (baselig gm2 2) (basecol gm2 2) 4)

(setf m0 (creer-matrice 2 3))
(inserer-terme (baselig m0 1) (basecol m0 1) 1)


(setf m1 (creer-matrice 2 2))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)

(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2+z4+z)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z2+z4)))
(setf mrph (build-fngn-abgroup-mrph :sorc gr1 :trgt gr2 :mtrx0 m0 :mtrx1 m1 :orgn '(group-morphism)))

(check-fngn-abgroup gr1)
(check-fngn-abgroup gr2)
(check-fngn-abgroup-mrph mrph)





(setf kr (kernel mrph))
(divisors (first kr))
(setf ck (cokernel mrph))
(divisors (first ck))

(kernel-element-image mrph '(0 0 1))
(kernel-element-image mrph '(0 1 0))



|#


(defun zero-list (n)
                      (let ((li nil))
                        (dotimes (i n)
                            (push 0 li))
                        li))


(defun 2lists-sum (l1 l2)
  (let ((rslt nil))
    (dotimes (i (length l1))
      (push (+ (nth i l1) (nth i l2)) rslt))
    (nreverse rslt)))


  
(defun central-extension (group1 group2 cocycle)
  (declare (type fngn-abgroup group1 group2)
           (type function cocycle))
  (let* ((mtrx1 (mtrx group1))
         (mtrx2 (mtrx group2))
         (nrow (nlig mtrx1))
         (ncol (ncol mtrx2))
         (vctr-list nil)
         )
    (if (= 0 nrow)
        (let ((mtrx (creer-matrice (nlig mtrx2) (nlig mtrx2))))
          (dotimes (i (nlig mtrx2)
                     (inserer-terme (baselig mtrx i) (basecol mtrx i) 1)))
        (list group2 mtrx mtrx))
    (progn
    
    (dotimes (i ncol)
        (let ((g (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- ncol i)))))
              (d (extract-term mtrx2 (1+ i) (1+ i)))
              (jg-list nil)
              (vctr (zero-list ncol)))
          (dotimes (j (- d 1))
            (push (nconc (zero-list (1- i)) (list (1+ j)) (zero-list (1- (- ncol i)))) jg-list))
          (mapcar #'(lambda (jg)
                      (setf vctr (2lists-sum vctr (funcall cocycle jg g))))
            jg-list)
          (setf vctr-list (push vctr vctr-list))))            
    (setf vctr-list (nreverse vctr-list))
    (let* ((new-mtrx (Gnrt-List-to-Mtrx vctr-list))
           (zero-mtrx (creer-matrice (nlig mtrx2) (ncol mtrx1)))
           (aux (mtrx-conc2 (mtrx-conc mtrx1 new-mtrx) (mtrx-conc zero-mtrx mtrx2)))
           (cn (canonical-representation aux))
           (mtrx (first cn))
           (inc (second cn))
           (proj (third cn)))
      (list
       (the fngn-abgroup
         (build-fngn-abgroup :mtrx mtrx :orgn `(Central extension of ,group2 by ,group1 with cocycle ,cocycle)))
       inc proj))))))        
    
          
          
#|
(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 3)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z3)))

(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 3))
                         (g2 (mod (first c2) 3))
                         (rslt
                          (if (< 3 (+ g1 g2)) 0
                            (if (= 3 (+ g1 g2)) 1
                              1)))) ;; Est mal definido pero slo voy a usar el caso anterior
                         (list rslt))))
(setf e (central-extension gr gr cocycle))
(divisors (first e))


(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 3)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z3)))

(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 3))
                         (g2 (mod (first c2) 3))
                         (rslt
                          (if (< 3 (+ g1 g2)) 0
                            (if (= 3 (+ g1 g2)) 0
                              0))))
                         (list rslt))))
(setf e (central-extension gr gr cocycle))
(divisors (first e))




(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 6)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z6)))

(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 6))
                         (g2 (mod (first c2) 6))
                         (rslt
                          (if (< 6 (+ g1 g2)) 0
                            (if (= 6 (+ g1 g2)) 1
                              1)))) ;; Est mal definido pero slo voy a usar el caso anterior
                         (list rslt))))
(setf e (central-extension gr gr cocycle))
(divisors (first e))


(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 6)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z6)))

(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 6))
                         (g2 (mod (first c2) 6))
                         (rslt
                          (if (< 6 (+ g1 g2)) 0
                            (if (= 6 (+ g1 g2)) 2
                              2)))) ;; Est mal definido pero slo voy a usar el caso anterior
                         (list rslt))))
(setf e (central-extension gr gr cocycle))
(divisors (first e))



(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 6)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z6)))

(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 6))
                         (g2 (mod (first c2) 6))
                         (rslt
                          (if (< 6 (+ g1 g2)) 0
                            (if (= 6 (+ g1 g2)) 3
                              3)))) ;; Est mal definido pero slo voy a usar el caso anterior
                         (list rslt))))
(setf e (central-extension gr gr cocycle))
(divisors (first e))




(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 6)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z6)))


(setf cocycle #'(lambda (c1 c2)
  (let* ((g1 (mod (first c1) 6))
         (g2 (mod (first c2) 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (first (funcall cocycle g1-1 g2)) 
                   (- (first (funcall cocycle 1 (+ g1 g2 -1)))
                      (first (funcall cocycle 1 g1-1)))))
              ))))
    (list rslt))))

(setf e (central-extension gr gr cocycle))
(divisors (first e))



(cat-init)
(setf gm (creer-matrice 1 1))
(inserer-terme (baselig gm 1) (basecol gm 1) 6)
(setf gr (build-fngn-abgroup :mtrx gm :orgn '(z6)))

(setf tg (trivial-group))
(setf cocycle2 #'(lambda (c1 c2)
                  nil))
(setf e (central-extension gr tg cocycle2))
(setf e (central-extension tg gr cocycle2))

|#
  


  

