;; EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY
;; EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY
;; EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY EFFECTIVE-HOMOTOPY

(IN-PACKAGE "COMMON-LISP-USER")

(provide "effective-homotopy")


;;;;;;;;;;;;;;;;;;;;;
;;;;; types and classes
;;;;;;;;;;;;;;;;;;;;;


(DEFTYPE EFFECTIVE-HOMOTOPY () 'function)


(DEFCLASS KAN-WITH-EFHMT (kan)
    (
     (efhmt :type effective-homotopy :initarg :efhmt :reader efhmt1)
     ))



(DEFVAR *kan-with-efhmt-list*)
(SETF *kan-with-efhmt-list* +empty-list+)
(PUSHNEW '*kan-with-efhmt-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((ss KAN-WITH-EFHMT) stream)
   (the KAN-WITH-EFHMT
     (progn
      (format stream "[K~D Kan-Simplicial-Set-with-Effective-Homotopy]" (idnm ss))
      ss)))

(DEFUN KAN-WITH-EFHMT (idnm)
   (declare (type fixnum idnm))
   (the (or KAN-WITH-EFHMT null)
     (find idnm *kan-with-efhmt-list* :key #'idnm)))

(defun build-kan-with-efhmt (&key cmpr basis bspn face face* intr-bndr bndr-strt
                                  intr-dgnl dgnl-strt kfll efhmt orgn)
  (declare
   (type cmprf cmpr)
   (type basis basis)
   (type gmsm bspn)
   (type face face)
   (type (or null face*) face*)
   (type (or intr-mrph null) intr-bndr intr-dgnl)
   (type (or strt null) bndr-strt dgnl-strt)
   (type kfll kfll)
   (type effective-homotopy efhmt)
   (list orgn))
  (let ((already (find orgn *kan-with-efhmt-list* :test #'equal :key #'orgn)))
    (declare (type (or kan-with-efhmt null) already))
    (when already
      (return-from build-kan-with-efhmt already)))
  (let ((rslt (build-smst
		:cmpr cmpr :basis basis :bspn bspn
		:face face :face* face* :intr-bndr intr-bndr
		:bndr-strt bndr-strt :intr-dgnl intr-dgnl
		:dgnl-strt dgnl-strt :orgn orgn)))
     (declare (type simplicial-set rslt))
     (change-class rslt 'kan-with-efhmt)
    (setf (slot-value rslt 'kfll) kfll (slot-value rslt 'efhmt) efhmt)
    (push rslt *kan-list*)
    (push rslt *kan-with-efhmt-list*)
    rslt))

(DEFUN SMST-WITH-EFHMT (smst kfll efhmt)
  (declare
     (type simplicial-set smst)
   (type kfll kfll)
   (type effective-homotopy efhmt))
  (the kan-with-efhmt
     (progn
       (change-class smst 'kan-with-efhmt)
       (setf (slot-value smst 'kfll) kfll)
       (setf (slot-value smst 'efhmt) efhmt)
       (pushnew smst *kan-list*)
       (pushnew smst *kan-with-efhmt-list*)
       smst)))



(DEFUN kan-TO-EFHMT (kan efhmt)
  (declare
   (type kan kan)
   (type effective-homotopy efhmt))
  (the kan-with-efhmt
     (progn
       (change-class kan 'kan-with-efhmt)
       (setf (slot-value kan 'efhmt) efhmt)
       (pushnew kan *kan-with-efhmt-list*)
       kan)))



(DEFCLASS SMGR-WITH-EFHMT (simplicial-group kan-with-efhmt)
    ())

(DEFVAR *smgr-with-efhmt-list*)
(SETF *smgr-with-efhmt-list* +empty-list+)
(PUSHNEW '*smgr-with-efhmt-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((ss SMGR-WITH-EFHMT) stream)
   (the SMGR-WITH-EFHMT
     (progn
      (format stream "[K~D Simplicial-Group-with-Effective-Homotopy]" (idnm ss))
      ss)))

(DEFUN SMGR-WITH-EFHMT (idnm)
   (declare (type fixnum idnm))
   (the (or SMGR-WITH-EFHMT null)
     (find idnm *smgr-with-efhmt-list* :key #'idnm)))

(defun build-smgr-with-efhmt (&key cmpr basis bspn
	face face* intr-bndr bndr-strt intr-dgnl dgnl-strt
	sintr-grml sintr-grin efhmt orgn)
  (declare
   (type cmprf cmpr)
   (type basis basis)
   (type gmsm bspn)
   (type face face)
   (type (or null face*) face*)
   (type (or intr-mrph null) intr-bndr intr-dgnl)
   (type (or strt null) bndr-strt dgnl-strt)
   (type sintr sintr-grml sintr-grin)
   (type effective-homotopy efhmt)
   (list orgn))
  (let ((already (find orgn *smgr-with-efhmt-list* :test #'equal :key #'orgn)))
    (declare (type (or smgr-with-efhmt null) already))
    (when already
      (return-from build-smgr-with-efhmt already)))
  (let ((rslt (build-smgr
		:cmpr cmpr :basis basis :bspn bspn
		:face face :face* face* :intr-bndr intr-bndr
		:bndr-strt bndr-strt :intr-dgnl intr-dgnl
            :dgnl-strt dgnl-strt :sintr-grml sintr-grml 
            :sintr-grin sintr-grin :orgn orgn)))
     (declare (type simplicial-group rslt))
     (change-class rslt 'smgr-with-efhmt)
    (setf (slot-value rslt 'efhmt) efhmt)
    (push rslt *smgr-with-efhmt-list*)
    rslt))

(DEFUN SMGR-TO-EFHMT (smgr efhmt)
  (declare
   (type simplicial-group smgr)
   (type effective-homotopy efhmt))
  (the smgr-with-efhmt
     (progn
       (change-class smgr 'smgr-with-efhmt)
       (setf (slot-value smgr 'efhmt) efhmt)
       (pushnew smgr *smgr-with-efhmt-list*)
       smgr)))


(DEFCLASS ABSMGR-WITH-EFHMT (ab-simplicial-group kan-with-efhmt)
    ())

(DEFVAR *absmgr-with-efhmt-list*)
(SETF *absmgr-with-efhmt-list* +empty-list+)
(PUSHNEW '*absmgr-with-efhmt-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((ss abSMGR-WITH-EFHMT) stream)
   (the abSMGR-WITH-EFHMT
     (progn
      (format stream "[K~D Abelian-Simplicial-Group-with-Effective-Homotopy]" (idnm ss))
      ss)))

(DEFUN ABSMGR-WITH-EFHMT (idnm)
   (declare (type fixnum idnm))
   (the (or ABSMGR-WITH-EFHMT null)
     (find idnm *absmgr-with-efhmt-list* :key #'idnm)))

(defun build-absmgr-with-efhmt (&key cmpr basis bspn
	face face* intr-bndr bndr-strt intr-dgnl dgnl-strt
	sintr-grml sintr-grin efhmt orgn)
  (declare
   (type cmprf cmpr)
   (type basis basis)
   (type gmsm bspn)
   (type face face)
   (type (or null face*) face*)
   (type (or intr-mrph null) intr-bndr intr-dgnl)
   (type (or strt null) bndr-strt dgnl-strt)
   (type sintr sintr-grml sintr-grin)
   (type effective-homotopy efhmt)
   (list orgn))
  (let ((already (find orgn *absmgr-with-efhmt-list* :test #'equal :key #'orgn)))
    (declare (type (or absmgr-with-efhmt null) already))
    (when already
      (return-from build-absmgr-with-efhmt already)))
  (let ((rslt (build-smgr-with-efhmt
		:cmpr cmpr :basis basis :bspn bspn
		:face face :face* face* :intr-bndr intr-bndr
		:bndr-strt bndr-strt :intr-dgnl intr-dgnl
            :dgnl-strt dgnl-strt :sintr-grml sintr-grml 
            :sintr-grin sintr-grin :efhmt efhmt :orgn orgn)))
     (declare (type simplicial-group-with-efhmt rslt))
     (change-class rslt 'absmgr-with-efhmt)
     (push rslt *absmgr-with-efhmt-list*)
    rslt))

(DEFUN abSMGR-TO-EFHMT (smgr efhmt)
  (declare
   (type ab-simplicial-group smgr)
   (type effective-homotopy efhmt))
  (the absmgr-with-efhmt
     (progn
       (change-class smgr 'absmgr-with-efhmt)
       (setf (slot-value smgr 'efhmt) efhmt)
       (pushnew smgr *absmgr-with-efhmt-list*)
       smgr)))



(defun homotopy-group (ss n)
  (divisors (gr (funcall (efhmt1 ss) n))))


(defun kfll-cmps (kfll face bspn dmns)
  (flet ((rslt (absm1 absm2)
               (let ((hat nil)
                     (m (mask (1+ dmns))))
                 (push absm2 hat)
                 (push absm1 hat)
                 (dotimes (i (1- dmns))
                   (push (absm m bspn) hat))
                 (let ((w (funcall kfll dmns (1+ dmns) hat)))
                   (a-face4 face dmns (1+ dmns) w)))))
    #'rslt))
  
  
(defun kfll-inv (kfll face bspn dmns)
  (flet ((rslt (absm)
               (let ((hat nil)
                     (m (mask (1+ dmns))))
                 (push (absm m bspn) hat)
                 (push absm hat)
                 (dotimes (i (1- dmns))
                   (push (absm m bspn) hat))
                 (let ((w (funcall kfll (1+ dmns) (1+ dmns) hat)))
                   (a-face4 face (1+ dmns) (1+ dmns) w)))))
    #'rslt))
                 

            
               


(DEFUN kzpn-efhmt-gr (p n dmns)
   (declare (type fixnum p n dmns))
  (if (= dmns n)
      (cyclic-group p)
    (trivial-group)))




(defun kzpn-efhmt-f (n dmns)
  (declare 
      (type fixnum n dmns))
  (flet ((rslt (absm)
               (declare 
                        (type absm absm))
               (with-absm (dgop gmsm) absm
                 (if (= dmns n)
                     (if (= 0 dgop) 
                         (if (= 1 n) gmsm
                           (progn
                         (dotimes (i (1- n))
                           (setf gmsm (gmsm (first (gbar-list gmsm)))))
                             (list (first gmsm))))
                       (list 0))
                   (list)))))
    #'rslt))



(defun zerogbar-list (n)
  (let ((rslt (list ))
        )
    (dotimes (i n)
      (let (( dgop (1- (expt 2 i))))
        (setf rslt (cons (absm dgop +NULL-GBAR+) rslt))
        ))
    rslt))

(defun gel-gbar (g n)
  (if (eq 1 n) (list g)
  (if (eq 2 n)
      (make-gbar :dmns 2 :list (list (absm 0 (list g)) (absm 0 nil)))
    (make-gbar :dmns n :list (cons (absm 0  (gel-gbar g (1- n))) (zerogbar-list (1- n)))))))

(defun gel-gbar1 (g n)
  (if (eq 1 n) g
  (if (eq 2 n)
      (make-gbar :dmns 2 :list (list (absm 0 g) (absm 0 nil)))
    (make-gbar :dmns n :list (cons (absm 0  (gel-gbar1 g (1- n))) (zerogbar-list (1- n)))))))



(defun kzpn-efhmt-g (n dmns)
  (declare (type fixnum n dmns))
  (flet ((rslt (e)
               (declare 
                        (type gnrt e))
               (if (and (= dmns n) (not (eq e 0)))
                   (absm 0 (gel-gbar1 e n))
                 (let ((bsgn (if (eq 1 n) nil +NULL-GBAR+)))
                   (absm (1- (expt 2 dmns)) bsgn)))))
    #'rslt))

  

(defun kzpn-efhmt-h (dmns)
  (declare (type fixnum dmns))
  (flet ((rslt ( absm)
               (declare 
                        (type absm absm))
               (with-absm (dgop gmsm) absm
                  (absm (1- (expt 2 (1+ dmns))) gmsm))))
    #'rslt))







(DEFUN K-Zp (p n)
   (declare (fixnum p n))
  (let ((rslt (the ab-simplicial-group
                (if (and (= p 0) (= n 0)) (k-z 0)
                  (if (and (= p 0) (= n 1)) (k-z 1)
                (if (= n 0) 
                    (k-g-0 (cyclicgroup p)) ;; aqu uso la versin antigua sin efhmt
                  (if (= n 1)
                      (k-g-1 (cyclicgroup p)) ;; aqu uso la versin antigua sin efhmt
                    (classifying-space (k-Zp p (1- n))))))))))
    (declare (type ab-simplicial-group rslt))
    (abSMGR-TO-EFHMT rslt 
                     #'(lambda (dmns)
                     (build-esg  
                      :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :nullel (absm (mask dmns) (bspn rslt))
                  :gr (kzpn-efhmt-gr p n dmns)
                  :f (kzpn-efhmt-f n dmns)
                  :g (kzpn-efhmt-g n dmns)
                  :h (kzpn-efhmt-h dmns)
                  :orgn `(Effective homotopy of K(Z,p ,n) ,dmns))))))


    
    

(defun k-zp-1 (p)
  (k-zp p 1))



#|

(setf kz32 (k-zp 3 2))
(setf kz31 (k-zp 3 1))
(homotopy-group kz31 2)
(homotopy-group kz31 1)



|#



(defun divisors-elements (l)
  (if (eq 1 (length l))
      (mapcar #'(lambda (i)
                  (list i))
        (<a-b> 0 (1- (first l))))
    (mapcan #'(lambda (a)
                (mapcar #'(lambda (c)
                            (cons a c))
                  (divisors-elements (rest l))))
                (<a-b> 0 (1- (first l))))))



(defun fngnabgr-elements (l)
  (let ((pos (position 0 l :test 'eq)))
    (if pos :locally-effective
      (divisors-elements l))))


(defun fngnabgr-mult (l)
   (declare 
     (type list l))
   (flet ((rslt (g1 g2)
                (declare (type list g1 g2))
                
                (mapcar #'(lambda (i)
                            (let ((pii (nth i l))
                                  (g1i (nth i g1))
                                  (g2i (nth i g2)))
                              (if (= 0 pii) (+ g1i g2i)
                                (mod (+ g1i g2i) pii))
                            ))
                  (<a-b< 0 (length l))))) 
             
     #'rslt))


(defun fngnabgr-inv (l)
   (declare 
     (type list l))
   (flet ((rslt (g1)
                (declare (type list g1))
                
                (mapcar #'(lambda (i)
                            (let ((pii (nth i l))
                                  (g1i (nth i g1))
                                  )
                              (if (= 0 pii) (- g1i)
                                (mod (- pii g1i) pii))
                            ))
                  (<a-b< 0 (length l))))) 
             
     #'rslt))



(defun fngnabgr-to-group (group)
   (declare
    (type fngn-abgroup group))
  (let* ((l (divisors-list group))
         (elements (fngnabgr-elements l))
         (cmpr #'l-cmpr)
         (mult (fngnabgr-mult l))
         (inv (fngnabgr-inv l))
         (nullel (zero-list (length l)))
         (orgn `(abelian group from ,group)))
    (the  ab-group (build-ab-group :elements elements :cmpr cmpr :mult mult :inv inv :nullel nullel :orgn orgn))))


(defun kg1-efhm-smst (l)
  (declare
   (list l))
  (if (= 1 (length l)) (k-zp-1 (first l))
    (crts-prdc (k-zp-1 (first l)) (kg1-efhm-smst (rest l)))))




(defun kg1-fintr ()
    (flet ((rslt (dmns bar)
               (let ((rslt-list nil))
                 (dotimes (i (length (first bar)))
                   (push (list 0 nil) rslt-list))
                   (let ((l 
                      (do ((indx 0 (1+ indx))
                           (bark 1 (ash bark +1)))
                           ((> indx (1- dmns)) 
                            rslt-list)
                           (let ((bar2 (pop bar)))
                             (do ((indx2 0 (1+ indx2)))
                            ((>= indx2 (length bar2)) 
                             ())
                               (let ((e (nth indx2 bar2))
                                     )
                                      (if (zerop e)
                                          (incf (first (nth indx2 rslt-list)) bark)
                                        (push e (second (nth indx2 rslt-list)))))
                            )))))
                     (let* ((ld (length l))
                            (dgop2 (first (nth (1- ld) l)))
                            (gmsm2 (nreverse  (second (nth (1- ld) l))))
                       )
                   (dotimes (i (1- ld))
                     (let ((dgop1 (first (nth (- ld (+ i 2)) l)))
                           (gmsm1 (nreverse (second (nth (- ld (+ i 2)) l)))))
                       (multiple-value-bind (dgop rslt-dgop1 rslt-dgop2) (extract-common-dgop dgop1 dgop2)
                         (declare (fixnum dgop dgop1 dgop2))
                         (setf dgop2 dgop)
                         (setf gmsm2 (crpr rslt-dgop1 gmsm1 rslt-dgop2 gmsm2)))))
                   (absm dgop2 gmsm2))))))
      (the intr-mrph #'rslt)))






(defun kg1-gintr ()
  (flet ((rslt (dmns crpr)
               (if (not (typep crpr 'crpr))
                   (let ((rslt-list 
                          (mapcar #'(lambda (e)
                                      (list e))
                            crpr)))
                     (absm 0 rslt-list))
               (let ((crpr-list nil)
                     (rslt-list nil))
                 (do ((dgop 0 (DGOP*DGOP dgop (dgop2 crpr1)))
                      (crpr1 crpr (gmsm2 crpr1))
                      )
                     ((not (typep (gmsm2 crpr1) 'crpr))
                      (progn
                        (push (g-absm-bar 0 (absm (DGOP*DGOP dgop (dgop1 crpr1)) (gmsm1 crpr1)))  crpr-list)
                        (push (g-absm-bar 0 (absm (DGOP*DGOP dgop (dgop2 crpr1)) (gmsm2 crpr1)))  crpr-list)
                        (setf crpr-list (nreverse crpr-list))))
                   (push (g-absm-bar 0 (absm (+ dgop (dgop1 crpr1)) (gmsm1 crpr1)))  crpr-list))
                 (dotimes (i (length (first crpr-list)))
                   (push nil rslt-list))
                 (dotimes (i (length crpr-list))
                   (dotimes (j (length (first crpr-list)))
                     (push (nth j (nth (1- (- (length crpr-list) i)) crpr-list)) (nth j rslt-list))))
                 (absm 0 rslt-list)))))
    (the intr-mrph #'rslt)))

  



#| 
(setf m (creer-matrice 3 3))
(inserer-terme (baselig m 1) (basecol m 1) 4)
(inserer-terme (baselig m 2) (basecol m 2) 4)
(inserer-terme (baselig m 3) (basecol m 3) 2)
(setf g (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(divisors g)
(setf x (kg1-efhm-smst (divisors-list g)))
(setf kg1 (k-g-1 (fngnabgr-to-group g)))

(cat-init)
(setf m (creer-matrice 1 1))
(inserer-terme (baselig m 1) (basecol m 1) 4)
(setf g (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(divisors g)
(setf x (kg1-efhm-smst (divisors-list g)))
(setf kg1 (k-g-1 (fngnabgr-to-group g)))


(setf gmsm2 (gmsm (funcall (kg1-fintr) 2 (first (basis kg1 2)))))
(setf n 2)
(setf n 1)
;;(setf n 3)
(dotimes (i (length (basis x n)))
  (let ((gmsm (gmsm (funcall (kg1-fintr) n (nth i (basis kg1 n)))))
        )
    (if (not (position gmsm (basis x n) :test #'(lambda (gnrt1 gnrt2)
                                                  (eq (cmpr x gnrt1 gnrt2) :equal))))
        (print i))))


(dotimes (i (length (basis x 1)))
  (print (nth i (basis x 1))))


(setf gmsm (nth 1 (basis x 2)))
(funcall (kg1-gintr) 2 gmsm)






(setf n 3)
(setf i 0)
(dotimes (i (length (basis x n)))
  (let ((gmsm (gmsm (funcall (kg1-gintr) n (nth i (basis x n)))))
        )
    (if (not (position gmsm (basis kg1 n) :test #'(lambda (gnrt1 gnrt2)
                                                  (eq (cmpr kg1 gnrt1 gnrt2) :equal))))
(print i))))
;;(print (nth i (basis x n)))
;;(print gmsm)))

(setf n 2)
(dotimes (i (length (basis x n)))
  (let* ((gmsm (gmsm (funcall (kg1-gintr) n (nth i (basis x n)))))
         (gmsm2 (gmsm (funcall (kg1-fintr) n gmsm))))
    (if (not (eq :equal (cmpr x gmsm2 (nth i (basis x n)))))
        (print i))))

(dotimes (i (length (basis kg1 n)))
  (let* ((gmsm (gmsm (funcall (kg1-fintr) n (nth i (basis kg1 n)))))
         (gmsm2 (gmsm (funcall (kg1-gintr) n gmsm))))
    (if (not (eq :equal (cmpr kg1 gmsm2 (nth i (basis kg1 n)))))
        (print i))))






|#




(DEFUN kgn-efhmt-gr (group n dmns)
  (declare 
   (type FNGN-ABGROUP group)
   (type fixnum n dmns))
             (if (= dmns n)
                group
               (trivial-group)))




(defun kgn-efhmt-f (group n dmns)
  (declare 
   (type FNGN-ABGROUP group)
      (type fixnum n dmns))
  (flet ((rslt (absm)
               (declare 
                        (type absm absm))
               (with-absm (dgop gmsm) absm
                 (if (= dmns n)
                     (if (= 0 dgop) 
                         (if (= 1 n) (first gmsm)
                           (progn
                         (dotimes (i (1- n))
                           (setf gmsm (gmsm (first (gbar-list gmsm)))))
                             (first gmsm)))
                    (zero-list (length (divisors-list group))))
                   (zero-list (length (divisors-list group)))))))
    #'rslt))






(defun kgn-efhmt-g (group n dmns)
  (declare (type fixnum dmns))
  (flet ((rslt (el)
               (declare 
                        (type gnrt el))
               (if (and (= dmns n) (not (cmbn-zerop group el)))
                   (absm 0 (gel-gbar el n))
                 (let ((bsgn (if (eq 1 n) nil +NULL-GBAR+)))
                   (absm (1- (expt 2 dmns)) bsgn)))))
    #'rslt))




 

(defun kgn-efhmt-h (dmns)
  (declare (type fixnum dmns))
  (flet ((rslt (absm)
               (declare 
                        (type absm absm))
               (with-absm (dgop gmsm) absm
                  (absm (1- (expt 2 (1+ dmns))) gmsm))))
    #'rslt))


(DEFMETHOD K-G-0 ((group FNGN-ABGROUP))
  (declare (type FNGN-ABGROUP group))
  (let ((orgn `(k-g-0 ,group)))
    (let ((already (find orgn *absmgr-with-efhmt-list* :test #'equal :key #'orgn)))
      (declare (type (or absmgr-with-efhmt null) already))
      (when already
        (return-from K-G-0 already)))
  (let* ((rslt (k-g-0 (fngnabgr-to-group group))))
    (declare (type ab-simplicial-group rslt))
    (setf (slot-value rslt 'orgn)  `(k-g-0 ,group))
    (abSMGR-TO-EFHMT rslt 
                     #'(lambda (dmns)
                         (build-esg  
                          :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :nullel (absm (mask dmns) (bspn rslt))
                          :gr (kgn-efhmt-gr group 0 dmns)
                          :f (kgn-efhmt-f group 0 dmns)
                          :g (kgn-efhmt-g group 0 dmns)
                          :h (kgn-efhmt-h dmns)
                          :orgn `(Effective homotopy of K(,group 0) ,dmns)))) 
    )))


(DEFMETHOD K-G-1 ((group FNGN-ABGROUP))
  (declare (type FNGN-ABGROUP group))
  (let ((orgn `(k-g-1 ,group)))
    (let ((already (find orgn *absmgr-with-efhmt-list* :test #'equal :key #'orgn)))
      (declare (type (or absmgr-with-efhmt null) already))
      (when already
        (return-from K-G-1 already)))
    (let* ((rslt (k-g-1 (fngnabgr-to-group group))))
      (declare (type ab-simplicial-group rslt))
      (setf (slot-value rslt 'orgn)  orgn)
      (abSMGR-TO-EFHMT rslt 
                       #'(lambda (dmns)
                         (build-esg  
                          :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :nullel (absm (mask dmns) (bspn rslt))
                          :gr (kgn-efhmt-gr group 1 dmns)
                          :f (kgn-efhmt-f group 1 dmns)
                          :g (kgn-efhmt-g group 1 dmns)
                          :h (kgn-efhmt-h dmns)
                          :orgn `(Effective homotopy of K(,group 1) ,dmns)))) 
      
      )))



(DEFMETHOD K-G ((group FNGN-ABGROUP) n)
   (declare (type FNGN-ABGROUP group)
           (fixnum n))
     (if (= n 0)
        (k-g-0 group)
        (if (= n 1)
            (k-g-1 group)
          (let ((rslt (classifying-space (k-g group (1- n)))))
            (declare (type ab-simplicial-group rslt))
            (abSMGR-TO-EFHMT rslt 
                             #'(lambda (dmns)
                         (build-esg  
                          :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                          :nullel (absm (mask dmns) (bspn rslt))
                          :gr (kgn-efhmt-gr group n dmns)
                          :f (kgn-efhmt-f group n dmns)
                          :g (kgn-efhmt-g group n dmns)
                          :h (kgn-efhmt-h dmns)
                          :orgn `(Effective homotopy of K(,group ,n) ,dmns)))) 
))))
                 
                 
(defun kg1-efhm (group)
  (declare
   (type fngn-abgroup group))
  (let* ((l (divisors-list group))
         (lbcc (k-g-1 group))
         (rbcc (kg1-efhm-smst l))
         (efhm (efhm rbcc))
         (f (build-smmr :sorc lbcc :trgt rbcc :degr 0 :sintr (kg1-fintr)
                        :orgn `(kg1-f ,group)))
         (g (build-smmr :sorc rbcc :trgt lbcc :degr 0 :sintr (kg1-gintr)
                        :orgn `(kg1-g ,group)))
         (lf (cmps g (lf efhm)))
         (lg (cmps (lg efhm) f))
         (lrdct (build-rdct :f lf :g lg :h (lh efhm) :orgn `(kg1-lrdct ,group))))
    (build-hmeq :lrdct lrdct :rrdct (rrdct efhm) :orgn `(kg1-efhm ,group))))



(DEFUN K-Z-1 ()
    (let* ((rslt 
            (change-class
     (build-ab-smgr
        :cmpr #'k-z-1-cmpr
	:basis :locally-effective
	:bspn +empty-list+
	:face #'k-z-1-face
	:sintr-grml #'k-z-1-grml
	:sintr-grin #'k-z-1-grin
      :orgn '(k-z-1))
             'ab-simplicial-group)))
      (declare (type ab-simplicial-group rslt))
      (abSMGR-TO-EFHMT rslt 
                       #'(lambda (dmns)
                     (build-esg  
                      :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :nullel (absm (mask dmns) (bspn rslt))
                  :gr (kzpn-efhmt-gr 0 1 dmns)
                  :f (kzpn-efhmt-f 1 dmns)
                  :g (kzpn-efhmt-g 1 dmns)
                  :h (kzpn-efhmt-h dmns)
                  :orgn `(Effective homotopy of K(Z 1) ,dmns))))))
 

(DEFMETHOD SEARCH-EFHM (smst (orgn (eql 'k-g-1)))
  (declare (type simplicial-group smst))
  (let ((group (second (orgn smst))))
    (if (typep group 'group)   
        (let* (
          (rsltn1 (bar-rsltn group))
          (rsltn2 (resolution group))
          (f (zgmrph-twi (2rsltn-zgmrph rsltn1 rsltn2)))
          (g (zgmrph-twi (2rsltn-zgmrph rsltn2 rsltn1)))
          (h (zgmrph-twi (2rsltn-hmtpop rsltn1 rsltn2)))
          (k (zgmrph-twi (2rsltn-hmtpop rsltn2 rsltn1)))
          (rrdct (cylinder-rrdct f))
          (lrdct (cylinder-lrdct f g h k)))
     (the equivalence
       (build-hmeq :lrdct lrdct :rrdct rrdct :orgn `(efhm of ,smst))))
      (if (typep group 'FNGN-ABGROUP)
          (the equivalence
            (kg1-efhm group))))))



(DEFMETHOD CLASSIFYING-SPACE ((smgr ABSMGR-WITH-EFHMT))
  (the ABSMGR-WITH-EFHMT
    (let* ((rslt 
            (change-class
             (build-smgr :cmpr (classifying-space-cmpr (cmpr smgr))
                         :basis (classifying-space-basis (basis smgr))
                         :bspn +null-gbar+
                         :face (classifying-space-face (face smgr) (sintr (grml smgr)))
                         :sintr-grml (classifying-space-grml-sintr
                                      (bspn smgr)
                                      (sintr (grml smgr)))
                         :sintr-grin (classifying-space-grin-sintr
                                      (sintr (grin smgr)))
                         :orgn `(classifying-space ,smgr))
              'ab-simplicial-group)))
      (declare (type ab-simplicial-group rslt))
      (do ((orgn (orgn smgr) (orgn (second orgn)))
           (n 1 (1+ n)))
          ((not (eq 'classifying-space (first orgn)))
           (if (eq 'k-g-1 (first orgn))
               (if (typep (second orgn) 'group)
                   (let ((p (length (elements (second orgn)))))
                     (abSMGR-TO-EFHMT rslt ;;(kzpn-efhmt p (1+ n))
                                      #'(lambda (dmns)
                                          (build-esg  
                                           :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                                           :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                                           :nullel (absm (mask dmns) (bspn rslt))
                                           :gr (kzpn-efhmt-gr p (1+ n) dmns)
                                           :f (kzpn-efhmt-f (1+ n) dmns)
                                           :g (kzpn-efhmt-g (1+ n) dmns)
                                           :h (kzpn-efhmt-h dmns)
                                           :orgn `(Effective homotopy of K(Z,p ,(1+ n)) ,dmns)))))
                 (let ((p 0)
                       (group (second orgn)))
                     (abSMGR-TO-EFHMT rslt ;;(kzpn-efhmt p (1+ n))
                                      #'(lambda (dmns)
                                          (build-esg  
                                           :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                                           :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                                           :nullel (absm (mask dmns) (bspn rslt))
                                           :gr (kgn-efhmt-gr group (1+ n) dmns)
                                           :f (kgn-efhmt-f group (1+ n) dmns)
                                           :g (kgn-efhmt-g group (1+ n) dmns)
                                           :h (kgn-efhmt-h dmns)
                                           :orgn `(Effective homotopy of K(,group ,(1+ n)) ,dmns)))
                                      
                                      ))
                   
                )
             (if (eq 'k-z-1 (first orgn))
               (abSMGR-TO-EFHMT rslt 
                       #'(lambda (dmns)
                     (build-esg  
                      :cmps (kfll-cmps (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :inv (kfll-inv (kfll rslt) (face rslt) (bspn rslt) dmns)
                  :nullel (absm (1- (expt 2 dmns)) (bspn rslt))
                  :gr (kzpn-efhmt-gr 0 (1+ n) dmns)
                  :f (kzpn-efhmt-f (1+ n) dmns)
                  :g (kzpn-efhmt-g (1+ n) dmns)
                  :h (kzpn-efhmt-h dmns)
                  :orgn `(Effective homotopy of K(Z ,(1+ n)) ,dmns))))))))
      rslt)))



(do ((temp-one 1 (1+ temp-one))
       (temp-two 0 (1- temp-two)))
      ((> (- temp-one temp-two) 5) temp-one))


#|
(cat-init)
(setf m (creer-matrice 3 3))
(inserer-terme (baselig m 1) (basecol m 1) 4)
(inserer-terme (baselig m 2) (basecol m 2) 4)
(inserer-terme (baselig m 3) (basecol m 3) 2)
(setf g (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(divisors g)
(setf kg1 (k-g-1 g))


(homotopy-group kg1 1)
(homotopy-group kg1 2)

(homology kg1 1)
(homology kg1 2)
(chml-clss kg1 1)


(cat-init)
(setf m (creer-matrice 3 3))
(inserer-terme (baselig m 1) (basecol m 1) 4)
(inserer-terme (baselig m 2) (basecol m 2) 4)
(inserer-terme (baselig m 3) (basecol m 3) 2)
(setf g (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(divisors g)
(setf kg3 (k-g g 3))


(homotopy-group kg3 1)
(homotopy-group kg3 2)
(homotopy-group kg3 3)
(homotopy-group kg3 4)

(homology kg3 1)
(homology kg3 2)
(homology kg3 3)
(homology kg3 4)






(cat-init)
(setf m (creer-matrice 2 2))
(inserer-terme (baselig m 1) (basecol m 1) 4)
(inserer-terme (baselig m 2) (basecol m 2) 2)
(setf g (build-fngn-abgroup :mtrx m :orgn   `(group ,m)))
(divisors g)
(setf kg1 (k-g-1 g))


(homotopy-group kg1 1)
(homotopy-group kg1 2)

(homology kg1 1)
(homology kg1 2)
(homology kg1 3)

(setf group g)
(setf l (divisors-list group))
(fngnabgr-elements l)

(setf n 1)






(setf g1 (kgn-efhmt-g group n n))
(setf f1 (kgn-efhmt-f group n n))

(setf i 0)
(dotimes (j (length (fngnabgr-elements l)))
  (print (nth j (fngnabgr-elements l)))
  (print (funcall f1 (funcall g1 (nth j (fngnabgr-elements l))))))


(dotimes (j (length (basis kg1 1)))
  (print (absm 0 (nth j (basis kg1 1))))
  (print (funcall g1 (funcall f1 (absm 0 (nth j (basis kg1 1)))))))


(setf kg2 (k-g group 2))
(homology kg2 3)
(homology kg2 4)


(setf n 2)
(setf g1 (kgn-efhmt-g group n n))
(setf f1 (kgn-efhmt-f group n n))

(dotimes (j (length (fngnabgr-elements l)))
  (print (nth j (fngnabgr-elements l)))
  (print (funcall f1 (funcall g1 (nth j (fngnabgr-elements l))))))

 
         
         
         
(dotimes (j (length (basis kg2 2)))
  (print (absm 0 (nth j (basis kg2 2))))
  (print (funcall g1 (funcall f1 (absm 0 (nth j (basis kg2 2)))))))


(setf kg4 (k-g group 4))
(setf n 4)
(setf g1 (kgn-efhmt-g group n n))
(setf f1 (kgn-efhmt-f group n n))

(dotimes (j (length (fngnabgr-elements l)))
  (print (nth j (fngnabgr-elements l)))
  (print (funcall f1  (funcall g1  (nth j (fngnabgr-elements l))))))

    
         
         
(dotimes (j (length (basis kg4 4)))
  (print (absm 0 (nth j (basis kg4 4))))
  (print (funcall g1  (funcall f1  (absm 0 (nth j (basis kg4 4)))))))


|#




(defun 2elements-homotopy (kfll face bspn)
  (flet ((rslt (dmns absm1 absm2 a)
               (let* ((w 
                      (let ((hat nil)
                            (m (mask (1+ dmns))))
                        (push (absm m bspn) hat)
                        (push absm2 hat)
                        (dotimes (i (1- dmns))
                          (push (absm m bspn) hat))
                        (funcall kfll (1+ dmns) (1+ dmns) hat)
                          ))
                     (z 
                      (let ((hat nil)
                            (m (mask (1+ dmns))))
                        (push (a-face4 face (1+ dmns) (1+ dmns) w) hat)
                        (push absm1 hat)
                        (dotimes (i (1- dmns))
                          (push (absm m bspn) hat))
                        (funcall kfll dmns (1+ dmns) hat))))
                 (let ((hat nil)
                       (m (mask (+ 2 dmns))))
                   (push z hat)
                   (push w hat)
                   (push a hat)
                   (dotimes (i (1- dmns))
                     (push (absm m bspn) hat))
                   
                   (let ((s (funcall kfll (1- dmns) (+ 2 dmns) hat)))
                     (a-face4 face (1- dmns) (+ 2 dmns) s))))))
    #'rslt))

                 
                      
                     
                     


 


                         
                     
                 
               
               




