(in-package :user)
(load "cat-init")
(load-cfiles)
(load "resolutions")
(load "fundamental-classes")
(load "central-extensions")
(load "cylinders")
(load "finitely-generated-groups")
(load "setoid-groups")
(load "effective-homotopy")
(load "spectral-sequences")
(load "kan-fibrations")




(defun Gnrt-List-to-Mtrx (gnrt-list)
   (declare (type list gnrt-list))
   (the matrice
     (let* ((column-n (length gnrt-list))
            (line-n (length (car gnrt-list)))
            (mat (creer-matrice line-n column-n))
            (res nil))
        (declare 
          (type fixnum column-n line-n)
         (type matrice mat)
         (type list res))
        (do ((j 0 (1+ j))
             (mark2 gnrt-list (cdr mark2)))
            ((endp mark2))
           (declare
            (type fixnum j)
            (list mark2)) 
           (if (eql line-n (length (car mark2)))
              (do ((i 0 (1+ i))
                   (mark1 (car mark2) (cdr mark1)))
                  ((endp mark1))
                 (declare 
                   (type fixnum i)
                  (list mark1))
                (let ((n (car mark1)))
                  (if (not (eql 0 n))
                      (push (list (1+ i) (list (list (1+ j) n))) res))
                 ))))
       (maj-matrice mat res))))

(Defun column-j (mtrx j)
   (declare (type matrix mtrx)
            (type fixnum j))
   (assert (<= j (column-number mtrx)))
   (the list
     (let ((line-n (line-number mtrx)))
        (declare (type fixnum line-n))
        (mapcar
         #'(lambda (i)
             (declare (type fixnum i))
             (let ((aij (extract-term mtrx i j)))
               (if aij aij 0)))
          (<a-b> 1 line-n)))))


(defun mtrx-conc (mtrx1 mtrx2)
   (declare (type matrix mtrx1 mtrx2))
   (the matrice
     (let* ((line-n-1 (line-number mtrx1))
            (column-n-1 (column-number mtrx1))
            (line-n-2 (line-number mtrx2))
            (column-n-2 (column-number mtrx2))
            (line-n (max line-n-1 line-n-2))
            (column-n (+ column-n-1 column-n-2)))
        (declare (type fixnum line-n-1 column-n-1 line-n-2
                   column-n-2 line-n column-n))
          (let ((mat (creer-matrice line-n column-n))
                (res nil))
            (declare (type list res))
            (dotimes (il line-n-1)
              (mapcar #'(lambda (pair)
                          (let ((ic (first pair)))
                            (push (list (1+ il) (list (list ic (second pair)))) res)))
              (extract-line mtrx1 (1+ il)))
              ) 
            (dotimes (il line-n-2)
              (mapcar #'(lambda (pair)
                          (let ((ic (+ (first pair) column-n-1)))
                            (push (list (1+ il) (list (list ic (second pair)))) res)))
              (extract-line mtrx2 (1+ il)))
            ) 
                
      (maj-matrice mat res)))))


(cat-init)

(progn
  (setf a (build-fngn-abgroup :divs '(6 0)))
  (setf b (cyclic-group 2))
  (setf m0 (build-mtrx :nrow 1 :ncol 2
                       :entries '(1 1)))
  (setf m1 (build-mtrx :nrow 1 :ncol 1
                       :entries '(3)))
  (setf gr-mrph1 (build-fngn-abgroup-mrph :sorc a
        :trgt b :mtrx0 m0 :mtrx1 m1)))

(check-fngn-abgroup-mrph gr-mrph1)

(setf ka1 (k-g a 1))

(setf kb1 (k-g b 1))

(setf esg1 (funcall (efhmt1 ka1) 1))

(setf esg2 (funcall (efhmt1 kb1) 1))

(progn
  (setf intr #'(lambda (absm)
                 (with-absm (dgop gmsm) absm
                   (if (= 0 dgop) (absm 0 (list (list (+ (first (first gmsm)) (second (first gmsm))))))
                     absm))))
  (setf esg-mrph1 (build-esg-mrph :sorc esg1 :trgt esg2 :intr intr)))


(mtrx0 esg-mrph1)
(mtrx1 esg-mrph1)


(divisors (first (mrph-kernel gr-mrph1)))
(divisors (first (mrph-cokernel gr-mrph1)))



(progn
  (setf a2 (build-fngn-abgroup :divs '(2 4 0)))
  (setf b2 (build-fngn-abgroup :divs '(2 4)))
  (setf m20 (build-mtrx :nrow 2 :ncol 3
                        :entries '(0 1 0 2 2 2)))
  (setf m21 (build-mtrx :nrow 2 :ncol 2
                        :entries '(0 2 1 2)))
  (setf gr-mrph2 (build-fngn-abgroup-mrph :sorc a2
        :trgt b2 :mtrx0 m20 :mtrx1 m21)))

 (check-fngn-abgroup-mrph gr-mrph2)

(divisors (first (mrph-kernel gr-mrph2)))

(divisors (first (mrph-cokernel gr-mrph2)))


(second (mrph-kernel gr-mrph2))
(second (mrph-cokernel gr-mrph2))


(setf cok (mrph-cokernel esg-mrph1))
(setf ker (mrph-kernel esg-mrph1))

(divisors (gr cok))
(divisors (gr ker))


(progn
     (setf z3 (cyclic-group 3))
     (setf cocycle3 #'(lambda (c1 c2)
                     '(0)))
  (setf e (first (central-extension z3 z3 cocycle3))))



(mtrx e)


(divisors e)

(progn
   (setf z6 (cyclic-group 6))
   (setf cocycle6 #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 6))
                         (g2 (mod (first c2) 6))
                         (rslt
                          (if (< (+ g1 g2) 6) 0
                            (if (= 6 (+ g1 g2)) 1
                              (let ((g1-1 (1- g1)))
                 (+ (first (funcall cocycle g1-1 g2))
          (- (first (funcall cocycle 1 (+ g1 g2 -1)))
                  (first (funcall cocycle 1 g1-1)))))
                              ))))
                    (list rslt))))
   (setf e2 (first (central-extension z3 z6 cocycle6)))
  (divisors e2))


(mtrx e2)



(progn
    (setf x1 (k-zp 0 3))
    (setf chmlcl1 (chml-clss x1 3))
    (setf chmlcl (n-mrph 3 chmlcl1))
    (setf twop (z-whitehead x1 chmlcl))
  (setf fib1 (twop-kanfibration twop)))


(setf fiber (sorc (incl1 fib1))
  base (trgt (fibr1 fib1)))


(homotopy-group fiber 2)

(homotopy-group base 3)


(homotopy-group fiber 10)

(homotopy-group fiber 100)

(homotopy-group base 5000)


(setf tot (sorc (fibr1 fib1)))


(homotopy-group tot 1) 
(homotopy-group tot 2)
(homotopy-group tot 3)






(progn
  (setf zero-twop2 (zero-twop tot (k-zp 3 2)))
  (setf fib2 (twop-kanfibration zero-twop2))
  (setf tot2 (sorc (fibr1 fib2))))



(homotopy-group tot2 1)
(homotopy-group tot2 2) 
(homotopy-group tot2 3)



(progn
    (setf zero-twop3 (zero-twop tot2 (k-zp 6 1)))
    (setf fib3 (twop-kanfibration zero-twop3))
    (setf tot3 (sorc (fibr1 fib3))))


(homotopy-group tot3 1) 
(homotopy-group tot3 2) 
(homotopy-group tot3 3)



(progn
    (setf p2 (k-zp 0 2))
    (setf ch4 (chml-clss p2 4))
    (setf f3 (z-whitehead p2 ch4))
    (setf pfib3(twop-kanfibration f3))
  (setf p3 (sorc (fibr1 pfib3))))



(homotopy-group p3 1)
(homotopy-group p3 2) 
(homotopy-group p3 3)


(progn
  (setf ch5 (chml-clss p3 5))
  (setf f4 (zp-whitehead 2 p3 ch5))
  (setf pfib4 (twop-kanfibration f4))
  (setf p4 (sorc (fibr1 pfib4)))
  (setf ch6 (chml-clss p4 6))
  (setf f5 (zp-whitehead 2 p4 ch6))
  (setf pfib5 (twop-kanfibration f5))
  (setf p5 (sorc (fibr1 pfib5)))
  (setf ch7 (chml-clss p5 7))
  (setf f6 (zp-whitehead 12 p5 ch7))
  (setf pfib6 (twop-kanfibration f6))
  (setf p6 (sorc (fibr1 pfib6))))

(homotopy-group p6 2) 
(homotopy-group p6 3)
(homotopy-group p6 4)
(homotopy-group p6 5)
(homotopy-group p6 6)








