;;;;  KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS
;;;;  KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS
;;;;  KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS KAN-FIBRATIONS


(IN-PACKAGE "COMMON-LISP-USER")

(provide "kan-fibrations")


(DEFTYPE KfFLL () 'function)
              ;; (function (indx dmns (list absm) absm) absm)

(DEFCLASS KAN-FIBRATION ()
  ((incl :type simplicial-mrph :initarg :incl :reader incl1)
   (incl-1 :type simplicial-mrph :initarg :incl-1 :reader incl-11)
   (fibr :type simplicial-mrph :initarg :fibr :reader fibr1)
   (kffll :type kffll :initarg :kffll :reader kffll1)
   (idnm :type fixnum :initform (incf *idnm-counter*) :reader idnm)
   (orgn :type list :initarg :orgn :reader orgn)
   ))


(DEFMETHOD INITIALIZE-INSTANCE :after ((kfr kan-fibration) &rest rest)
  (set (intern (format nil "K~D" (idnm kfr))) kfr))


(DEFVAR *kan-fibration-list*)
(SETF *kan-fibration-list* +empty-list+)
(PUSHNEW '*kan-fibration-list* *list-list*)


(DEFMETHOD PRINT-OBJECT ((kfr kan-fibration) stream)
   (the kan-fibration
     (progn
      (format stream "[K~D Kan-fibration]" (idnm kfr))
      kfr)))


(DEFUN KAN-FIBRATION (idnm)
   (declare (type fixnum idnm))
   (the (or kan-fibration null)
     (find idnm *kan-fibration-list* :key #'idnm)))


(DEFMACRO KFFLL (&rest rest)
  (ecase (length rest)
     (1 `(kffll1 ,@rest))
     (5 `(kffll5 ,@rest))))

(DEFMACRO KFFLL5 (fibr indx dmns hat b)
  `(funcall (kffll1 ,fibr) ,indx ,dmns ,hat ,b))





(defun build-kfbr (&key incl incl-1 fibr kffll orgn)
  (declare 
   (type simplicial-mrph incl incl-1 fibr)
   (type kffll kffll)
   (list orgn))
   (the kan-fibration
     (progn
      (let ((already (find orgn *kan-fibration-list* :test #'equal :key #'orgn)))
         (declare (type (or kan-fibration null) already))
         (when already
            (return-from build-kfbr already)))
       (let ((kfbr (make-instance 'kan-fibration
                     :incl incl
                     :incl-1 incl-1
                     :fibr fibr
                     :kffll kffll
                     :orgn orgn)))
         (declare (type kan-fibration kfbr))   
         (push kfbr *kan-fibration-list*)
         kfbr))))


(DEFUN CHECK-FIBR-HAT (fibr indx dmns hat b)
  (declare
   (type simplicial-morphism fibr)
   (type fixnum indx dmns)  ;;; dmns like in (funcall kfll ...)
   (list hat)
   (absm b))
  (let ((sorc (sorc fibr))
        (trgt (trgt fibr)))
    (declare (type simplicial-set sorc trgt))
    (check-hat (sorc fibr) indx dmns hat)
    (assert (= dmns (length hat)))
    (setf hat
      (append (subseq hat 0 indx)
              (list :hole)
              (nthcdr indx hat)))
  (do ((cmpr (cmpr trgt))
       (j 0 (1+ j)))
      ((> j dmns) t)
    (declare
     (type cmprf cmpr)
     (type fixnum j))
    (unless (= j indx)
      (let* ((xj (nth j hat))
             (del-j-b (face trgt j dmns b))
             (fxj (? fibr (1- dmns) xj)))
        (declare (type absm xj del-j-b fxj))
        (assert (eq :equal
                    (a-cmpr3 cmpr del-j-b fxj))))))))



(DEFUN CHECK-KAN-FIBR (kan-fibr indx dmns hat b)
  (declare
   (type kan-fibration kan-fibr)
   (type fixnum indx dmns)
   (list hat)
   (absm b))
  (the (values)
    (let* ((rslt (kffll kan-fibr indx dmns hat b))
          (fibr (fibr1 kan-fibr))
          (sorc (sorc fibr))
          (trgt (trgt fibr))
          (scmpr (cmpr sorc))
          (tcmpr (cmpr trgt))
          (face (face sorc)))
       (declare
        (type absm rslt)
        (simplicial-set  sorc trgt)
	  (type cmprf scmpr tcmpr)
	  (type face sorc))
      (check-fibr-hat fibr indx dmns hat b)
      (let ((fx (? fibr dmns rslt)))
        (with-absm (dgop1 gmsm1) b
	      (with-absm (dgop2 gmsm2) fx
         (unless (and (= dgop1 dgop2)
                      (eq (funcall tcmpr gmsm1 gmsm2) :equal))
          (error "Wrong result:~@
                            Fill = ~A~@
                            f(Fill) = ~A~@
                            b = ~A"
		       rslt  fx b)))))
          
          (do ((i 0 (1+ i)))
	   ((> i dmns))
	  (declare (type fixnum i))
	  (unless (= i indx)
	    (let ((x-i (pop hat))
		  (del-i-rslt (a-face4 face i dmns rslt)))
	      (declare (type absm x-i del-i-rslt))
	      (with-absm (dgop1 gmsm1) x-i
	      (with-absm (dgop2 gmsm2) del-i-rslt
		 (unless (and (= dgop1 dgop2)
			      (eq (funcall scmpr gmsm1 gmsm2) :equal))
		    (error "Wrong result:~@
                            Fill = ~A~@
                            Del-~D(Fill) = ~A~@
                            Hat-~D = ~A"
		       rslt i del-i-rslt i x-i)))))))
      (done))))




(defun twop-incl-intr (twop)
  (declare (type fibration twop))
  (flet ((rslt (dmns gmsm)
               (absm 0 (crpr  (1- (expt 2 dmns)) (bspn (sorc twop)) 0 gmsm))
   ))
    (the intr-mrph #'rslt)))

(defun twop-incl-1-intr (twop)
  (declare (type fibration twop))
  (flet ((rslt (dmns gmsm)
               (with-crpr (dgop1 gmsm1 dgop2 gmsm2) gmsm
                 (absm dgop2 gmsm2))
                  ))
    (the intr-mrph #'rslt)))

 
(defun twop-proj-intr (twop)
  (declare (type fibration twop))
  (flet ((rslt (dmns gmsm)
               (with-crpr (dgop1 gmsm1 dgop2 gmsm2) gmsm
                 (absm dgop1 gmsm1))
                  ))
    (the intr-mrph #'rslt)))





#|
(defun twop-kffll (twop)
  (declare (type fibration twop))
  (flet ((rslt (indx dmns hat b
		     &aux (dmns-1 (1- dmns)))
               (declare
                (type fixnum indx dmns dmns-1)
                (list hat)
                (type absm b))
               (the absm
                 (let ((base (sorc twop))
                       (fiber (trgt twop))
                       (f-hat nil))
                   (dotimes (i (length hat))
                     (let (xi (nth i hat))
                       (with-crpr (dgop1 gmsm1 dgop2 gmsm2) xi
                         (push f-hat (absm dgop2 gmsm2)))))
                   (setf f-hat (nreverse f-hat))
                   (let ((f
                          (if (= indx 0)  (kfll fiber indx dmns f-hat)
                            (let ((f0 (grml fiber (1+ dmns) (grinv fiber (1+ dmns) b) (first f-hat))))
                              (pop f-hat)
                              (push f-hat f0)
                              (kfll fiber indx dmns f-hat)))))
                     (with-absm (dgopb gmsmb) b
                       (with-absm (dgopf gmsmf) f
                         (multiple-value-bind (dgop dgop1 dgop2) (extract-common-dgop dgopf dgopb)
                           (absm dgop (crpr dgop1 (gmsm f ) dgop2 (gmsm b)))))))
	      ))))
    (the kfll #'rslt)))
|#



(DEFUN twop-kffll (twop
                       &aux (sintr-twop (sintr twop))
			     (base (sorc twop))
			     (fibre (trgt twop))
			     (fbspn (bspn fibre))
                       (fkfll (kfll fibre))
			     (sintr-grml (sintr (grml fibre)))
			     (sintr-grin (sintr (grin fibre))))
  (declare
     (type fibration twop)
     (type kan base fibre)
     (type gmsm fbspn)
     (type kfll fkfll)
     (type sintr sintr-grml sintr-grin))
  (flet ((rslt (indx dmns hat b)
               (declare
                (fixnum indx dmns)
                (list hat)
                (type absm b))
               (let (fhat)
                 (declare (type list fhat))
                 (do ((mark hat (cdr mark)))
                     ((endp mark))
                   (declare (list mark))
                   (let ((absm (car mark)))
                     (declare (type absm absm))
                     (with-absm (dgop crpr) absm
                       (with-crpr (dgop1 gmsm1 dgop2 gmsm2) crpr
                         (push (absm (dgop*dgop dgop dgop2) gmsm2) fhat)))))
                           
                   (when (< indx dmns)
                     (setf (first fhat)
                       (a-grml4 sintr-grml (1- dmns)
                                (a-grin4 sintr-grin (1- dmns)
                                         (tw-a-sintr3 sintr-twop dmns b fbspn))
                                (first fhat))))
                   (setf fhat (nreverse fhat))
                   (let ((fkfll (funcall fkfll indx dmns fhat)))
                     (declare (type absm fkfll))
                     (2absm-acrpr b fkfll)))))
    (the kffll #'rslt)))



(defun twop-kanfibration (twop)
  (declare (type fibration twop))
  (let* ((orgn `(Kan-fibration-from-twop ,twop))
         (already (find orgn *kan-fibration-list* :test #'equal :key #'orgn)))
    (declare (type (or kan-fibration null) already))
    (when already
      (return-from twop-kanfibration already))
    (let* ((base (sorc twop))
           (fiber (trgt twop))
           (total (fibration-total twop))
           (incl (build-smmr :sorc fiber :trgt total :degr 0 :sintr (twop-incl-intr twop)
                             :orgn `(kan-fibration-inclusion ,twop)))
           (incl-1 (build-smmr :sorc total :trgt fiber :degr 0 :sintr (twop-incl-1-intr twop)
                               :orgn `(kan-fibration-inclusion-1 ,twop)))
           (fibr (build-smmr :sorc total :trgt base :degr 0 :sintr (twop-proj-intr twop)
                             :orgn orgn)))
      (change-class total 'KAN-WITH-EFHMT)
      (the kan-fibration
        (build-kfbr :incl incl :incl-1 incl-1 :fibr fibr 
                    :kffll (twop-kffll twop) :orgn `(Kan-fibration-from-twop ,twop))))))


(defun zero-twop (base fiber)
  (declare (type simplicial-group base fiber))
  (build-smmr
   :sorc base :trgt fiber :degr -1
   :sintr #'(lambda (dmns gmsm)
              (absm (mask (1- dmns)) (bspn fiber))) ;;; mask(n)=2^n - 1
   :orgn   `(null twisting operator from ,base to ,fiber)))



#|


(cat-init)
(setf kz23 (k-zp 2 3))
(setf kz32 (k-zp 3 2))
(setf zero-twop (zero-twop kz23 kz32))
(setf fib (twop-kanfibration zero-twop))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))

(dotimes (i (length (basis kz32 3)))
  (print i)
  (print (? fi 3 (nth i (basis kz32 3)))))

(dotimes (i (length (basis kz32 4)))
  (print i)
  (print (? fi 4 (nth i (basis kz32 4)))))

(dotimes (n 4)
  (progn 
    (print n)
    (dotimes (i (length (basis e n)))
      (progn 
        (print i)
        (dotimes (k (1+ n))
          (let* ((x (nth i (basis e n)))
                 (b (? proj n x))
                 (hat nil))
            (progn 
              (print k)
              (dotimes (j (1+ n))
                (if (not (eq j k))
                    (push (face e j n x) hat)))
              (setf hat (nreverse hat))
              (CHECK-KAN-FIBR fib k n hat b))))))))



(cat-init)
(setf kz2 (k-zp 0 2))
(setf kz3 (k-zp 0 3))
(setf zero-twop (zero-twop kz3 kz2))
(setf fib (twop-kanfibration zero-twop))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))


(dotimes (i (length (basis kz32 4)))
  (print i)
  (print (? fi 4 (nth i (basis kz32 4)))))






(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz31 (k-zp 3 1))
(setf zero-twop (zero-twop kz21 kz31))
(setf fib (twop-kanfibration zero-twop))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))


(dotimes (n 4)
  (progn 
    (print n)
    (dotimes (i (length (basis e n)))
      (progn 
        (print i)
        (dotimes (k (1+ n))
          (let* ((x (nth i (basis e n)))
                 (b (? proj n x))
                 (hat nil))
            (progn 
              (print k)
              (dotimes (j (1+ n))
                (if (not (eq j k))
                    (push (face e j n x) hat)))
              (setf hat (nreverse hat))
              (CHECK-KAN-FIBR fib k n hat b))))))))


(cat-init)
(setf s2 (sphere 2))
(setf kz21 (k-zp 2 1))
(setf tw2 (build-smmr
           :sorc s2
           :trgt kz21
           :degr -1
           :sintr #'(lambda (dmns gmsm) (absm 0 '(1)))
           :orgn '(s2-tw-kz2)))
(setf fib (twop-kanfibration tw2))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))


(dotimes (i (length (basis kz21 4)))
  (print i)
  (print (? fi 4 (nth i (basis kz21 4)))))


(dotimes (n 6)
  (progn 
    (print n)
    (dotimes (i (length (basis e n)))
      (progn 
        (print i)
        (dotimes (k (1+ n))
          (let* ((x (nth i (basis e n)))
                 (b (? proj n x))
                 (hat nil))
            (progn 
              (print k)
              (dotimes (j (1+ n))
                (if (not (eq j k))
                    (push (face e j n x) hat)))
              (setf hat (nreverse hat))
              (CHECK-KAN-FIBR fib k n hat b))))))))



(cat-init)
(setf x1 (k-zp 0 2))
(chml-clss x1 2)
(n-mrph 3 *)
(z-whitehead x1 *)
(fibration-total *)
(setf x2 *)
;;; *** Should be a model for K(Z/3,1).
(setf kz3 (k-zp 3 1))
(homology x2 0)
(homology kz3 0)
(homology x2 1)
(homology kz3 1)
(homology x2 2)
(homology kz3 2)
(homology x2 3)
(homology kz3 3)
(homology x2 4)
(homology kz3 4)
(homology x2 5)
(homology kz3 5)
(homology x2 6)
(homology kz3 6)
(homology x2 7)
(homology kz3 7)



(cat-init)
(setf x1 (k-zp 0 3))
(chml-clss x1 3)
(n-mrph 3 *)
(setf twop (z-whitehead x1 *))
(fibration-total *)
(setf x2 *)
;;; *** Should be a model for K(Z/3,2).
(setf kz32 (k-zp 3 2))
(homology x2 0)
(homology kz32 0)
(homology x2 1)
(homology kz32 1)
(homology x2 2)
(homology kz32 2)
(homology x2 3)
(homology kz32 3)
(homology x2 4)
(homology kz32 4)
(homology x2 5)
(homology kz32 5)
(homology x2 6)
(homology kz32 6)
(homology x2 7)
(homology kz32 7)
(homology x2 8)
(homology kz32 8)


(setf fib (twop-kanfibration twop))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))


(setf e2 (crts-prdc (k-zp 4 3) (k-zp 4 2)))


(dotimes (i (length (basis (k-zp 4 2) 3)))
  (print i)
  (print (? fi 4 (nth i (basis (k-zp 4 2) 3)))))


(dotimes (n 6)
  (progn 
    (print n)
    (dotimes (i (length (basis e2 n)))
      (progn 
        (print i)
        (dotimes (k (1+ n))
          (let* ((x (nth i (basis e2 n)))
                 (b (? proj n x))
                 (hat nil))
            (progn 
              (print k)
              (dotimes (j (1+ n))
                (if (not (eq j k))
                    (push (face e j n x) hat)))
              (setf hat (nreverse hat))
              (CHECK-KAN-FIBR fib k n hat b))))))))


(setf group sgroup n 3)
(setf dmns 3 el '(1))

               (if (and (= dmns n) (not (cmbn-zerop group el)))
                   (absm 0 (gel-gbar el n))
                 (let ((bsgn (if (eq 1 n) nil +NULL-GBAR+)))
                   (absm (1- (expt 2 n)) bsgn)))))
    #'rslt))

|#



(defun kan-fibr-cnmrph-intr (kffll incl-1 bspn tot-face n)
  (declare 
   (type kffll kffll)
   (type gnrt bspn)
   (type face tot-face)
   (fixnum n))
  (flet ((rslt (dmns gmsm)
               (let ((hat nil)
                     (m (mask dmns)))
                 (dotimes (i n)
                   (push (absm m bspn) hat))
                 (let ((x (funcall kffll 0 dmns hat (absm 0 gmsm))))
                   (?3 incl-1 (1- dmns) (a-face4 tot-face 0 dmns x))))))
    (the intr-mrph #'rslt)))

#|

(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz22 (k-zp 2 2))
(setf zero-twop (zero-twop kz22 kz21))
(setf fib (twop-kanfibration zero-twop))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))

(setf kffll (kffll fib))
(setf bspn (bspn e))
(setf tot-face (face e))
(setf n 2)

(setf intr (kan-fibr-cnmrph-intr kffll bspn tot-face n))
(setf base (trgt proj))
(funcall intr 2 (first (basis base 2)))



(cat-init)
(setf x1 (k-zp 2 2))
(chml-clss x1 2)
;;(n-mrph 3 *)
(setf twop (z-whitehead x1 *))
(fibration-total *)
(setf x2 *)


(setf fib (twop-kanfibration twop))

(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf fi (cmps  proj incl))
(setf e (trgt incl))


(setf kffll (kffll fib))
(setf bspn (bspn e))
(setf tot-face (face e))
(setf n 2)

(setf intr (kan-fibr-cnmrph-intr kffll bspn tot-face n))
(setf base (trgt proj))
(funcall intr 2 (first (basis base 2)))


     


|#






(defun intr-to-group-mrph (sgroup tgroup sg tf intr sdegr tdegr)
  (declare 
   (type FNGN-ABGROUP sgroup tgroup)
   (type function sf tg)
   (type intr-mrph intr)
   (type fixnum sdegr))
  (let* ((smtrx (mtrx sgroup))
         (tmtrx (mtrx tgroup))         
         (mtrx0-gnrt-list nil)
         (mtrx1-gnrt-list nil))
    (dotimes (i (nlig smtrx))
      (let* ((gnrti (nconc (zero-list i) (list 1) (zero-list (1- (- (nlig smtrx) i)))))
             (ggnrti (funcall sg sdegr gnrti)))
        (with-absm (dgop gmsm) ggnrti
          (let ((imgi
                 (if (not (= 0 dgop)) (zero-list (nlig tmtrx))  
                   (funcall tf tdegr (funcall intr sdegr gmsm)))))
            (push imgi mtrx0-gnrt-list)))))
    (setf mtrx0-gnrt-list (nreverse mtrx0-gnrt-list))
    (let ((mtrx0 (if (= 0 (nlig tmtrx))
                     (creer-matrice 0 (nlig smtrx))
                   (if mtrx0-gnrt-list (Gnrt-List-to-Mtrx mtrx0-gnrt-list)
                     (creer-matrice (nlig tmtrx) 0 )))
           ))
      (dotimes (i (ncol smtrx)) 
        (let* ((iimgi (column-j (mtrx-prdc mtrx0 smtrx) (1+ i)))
               (imgi 
                (mapcar #'(lambda (j)
                            (let* ((aj (nth j iimgi))
                                   (dj (extract-term tmtrx (1+ j) (1+ j)))
                                   )
                              (if (= 0 dj) aj
                                (/ aj dj))))
                              (<a-b< 0 (nlig tmtrx)))))
          (push imgi mtrx1-gnrt-list)))
      (setf mtrx1-gnrt-list (nreverse mtrx1-gnrt-list))
      (let ((mtrx1 (if (= 0 (ncol tmtrx))
                     (creer-matrice 0 (ncol smtrx))
                     (if mtrx1-gnrt-list (Gnrt-List-to-Mtrx mtrx1-gnrt-list)
                   (creer-matrice (ncol tmtrx) 0 )))))
        (BUILD-fngn-abgroup-mrph :sorc sgroup :trgt tgroup :mtrx0 mtrx0 :mtrx1 mtrx1
                                 :orgn `(Group morphism from ,sgroup to ,tgroup 
                                               in degree ,sdegr from ,intr))))))


      

               

      
#|



(cat-init)
(setf kz23 (k-zp 2 3))
(setf kz32 (k-zp 3 2))
(setf zero-twop (zero-twop kz23 kz32))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)




(cat-init)
(setf kz2 (k-zp 0 2))
(setf kz3 (k-zp 0 3))
(setf zero-twop (zero-twop kz3 kz2))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)




(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz31 (k-zp 3 1))
(setf zero-twop (zero-twop kz21 kz31))
(setf fib (twop-kanfibration zero-twop))

(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 2)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 2))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 2 tdegr 1)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)




(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz31 (k-zp 3 1))
(setf zero-twop (zero-twop kz21 kz31))
(setf fib (twop-kanfibration zero-twop))

(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 0))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)



(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)










;;; El siguiente ejemplo al final no lo he terminado porque hace falta
;;; la homotopa efectiva de un producto cartesiano

(cat-init)
(setf g1m (creer-matrice 2 2))
(inserer-terme (baselig g1m 1) (basecol g1m 1) 2)
(inserer-terme (baselig g1m 2) (basecol g1m 2) 4)
(setf gr1 (build-fngn-abgroup :mtrx g1m :orgn '(z2+z4)))
(setf kgr13 (k-g gr1 3))

(setf g2m (creer-matrice 2 1))
(inserer-terme (baselig g2m 1) (basecol g2m 1) 6)
(setf gr2 (build-fngn-abgroup :mtrx g2m :orgn '(z6+z)))
(setf kgr21 (k-g gr2 1))


(setf kz3 (k-zp 0 3))
(setf chmlcl1 (chml-clss kz3 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop1 (z-whitehead kz3 chmlcl))
(setf kz2 (k-zp 0 2))


(setf twop-intr #'(lambda (dmns crpr)
                    (with-crpr (dgop1 gmsm1 dgop2 gmsm2)
                      (let ((rslt (crpr (absm (mask (1- dmns)) (bspn kgr11))  
                                        (tw-a-sintr3 sintr-twop dmns (absm dgop2 gmsm2) (bspn kz3)))))
                        (multiple-value-bind (dgop rslt-dgop1 rslt-dgop2) (extract-common-dgop dgop1 dgop2)

                              (absm dgop (crpr rslt-dgop1 (gmsm1 rslt) rslt-dgop2 (gmsm2 rslt)))
   )))
                    (the intr-mrph #'rslt)))

(setf twop 
  (build-smmr
   :sorc (crts-prdc kgr21 kz3) :trgt (crts-prdc kgr13 kz2) :degr -1
   :sintr twop-intr
   :orgn   `(twisting operator example)))
|#

(DEFUN crts-prdc-GRML (smgr1 smgr2)
  (let ((sintr-grml1 (sintr (grml smgr1)))
        (sintr-grml2 (sintr (grml smgr2))))
    (flet ((rslt (dmns crpr)
                 (declare
                  (type fixnum dmns)
                  (type crpr crpr))
                 (the absm
                   (with-crpr (dgop1 gmsm1 dgop2 gmsm2) crpr
                     (with-crpr (dgop11 gmsm11 dgop12 gmsm12) gmsm1
                       (with-crpr (dgop21 gmsm21 dgop22 gmsm22) gmsm2
                         (let* ((d11 (dgop*dgop dgop1 dgop11))
                                (d12 (dgop*dgop dgop1 dgop12))
                                (d21 (dgop*dgop dgop2 dgop21))
                                (d22 (dgop*dgop dgop2 dgop22))
                                (rslt1 (a-grml4 sintr-grml1 dmns (absm d11 gmsm11) (absm d21 gmsm21)))
                                (rslt2 (a-grml4 sintr-grml2 dmns (absm d12 gmsm12) (absm d22 gmsm22))))
                           (with-absm (rslt1-dgop rslt1-gmsm) rslt1
                             (with-absm (rslt2-dgop rslt2-gmsm) rslt2
                               
                                 (multiple-value-bind (final-dgop final-dgop1 final-dgop2) 
                                     (extract-common-dgop rslt1-dgop rslt2-dgop)
                                   (absm final-dgop (crpr final-dgop1 rslt1-gmsm final-dgop2 rslt2-gmsm))))))))))))
      (the intr-mrph #'rslt))))



#|
(setf kz31 (k-zp 3 1))
(setf kz312 (crts-prdc kz31 kz31))
(setf grml (crts-prdc-GRML kz31 kz31))
(setf gmsm1 (nth 0 (basis kz312 1)) gmsm2 (nth 1 (basis kz312 1)))
(funcall grml 1 (crpr 0 gmsm1 0 gmsm2))

(setf gmsm1 (nth 0 (basis kz312 2)) gmsm2 (nth 1 (basis kz312 1)))
(funcall grml 2 (crpr 0 gmsm1 1 gmsm2))


|#



(DEFUN crts-prdc-GRin (smgr1 smgr2)
  (let ((sintr-grml1 (sintr (grin smgr1)))
        (sintr-grml2 (sintr (grin smgr2))))
    (flet ((rslt (dmns crpr)
                 (declare
                  (type fixnum dmns)
                  (type crpr crpr))
                 (the absm
                   (with-crpr (dgop1 gmsm1 dgop2 gmsm2) crpr
                      (let ((rslt1 (a-grin4 sintr-grml1 dmns (absm dgop1 gmsm1)))
                            (rslt2 (a-grin4 sintr-grml2 dmns (absm dgop2 gmsm2))))
                           (with-absm (rslt1-dgop rslt1-gmsm) rslt1
                             (with-absm (rslt2-dgop rslt2-gmsm) rslt2
                               (multiple-value-bind (final-dgop final-dgop1 final-dgop2) 
                                   (extract-common-dgop rslt1-dgop rslt2-dgop)
                                 (absm final-dgop (crpr final-dgop1 rslt1-gmsm final-dgop2 rslt2-gmsm))))))))))
      (the intr-mrph #'rslt))))


(defun smst-to-absmgr (smst grml-intr grin-intr)
    (the AB-SIMPLICIAL-GROUP
     (progn
       (change-class smst 'AB-SIMPLICIAL-GROUP)
       (setf (slot-value smst 'grml)
         (build-smmr
          :sorc (crts-prdc smst smst) :trgt smst :degr 0
          :sintr grml-intr :orgn `(group-multiplication ,smst))
         (slot-value smst 'grin)
         (build-smmr
          :sorc smst :trgt smst :degr 0
          :sintr grin-intr :orgn `(group-inversion ,smst)))
       (push smst *smgr-list*)
       smst)))

(defun crts-prdc-to-smgr (smst1 smst2 crpr)
  (smst-to-absmgr crpr (crts-prdc-GRML smst1 smst2) (crts-prdc-GRin smst1 smst2)))







(defun kan-fibr-section (kffll incl incl-1 bspn tot-face bg fh tot-kfll)
  (declare 
   (type kffll kffll)
   (type gnrt bspn)
   (type face tot-face))
  (flet ((rslt (dmns e)
               (declare (type fixnum dmns)
                        (type list e))
               (let ((hat nil)
                      (b (funcall bg dmns e))
                      (m (mask dmns))
                      )
                 (dotimes (i dmns)
                   (push (absm m bspn) hat))
                 (let* ((x (funcall kffll 0 dmns hat b))
                        (del0x (?3 incl-1 (1- dmns) (a-face4 tot-face 0 dmns x)))
                        (z (funcall fh (1- dmns) del0x))
                        (hat2 nil))
                   (push x hat2)
                   (dotimes (i (1- dmns))
                     (push (absm m bspn) hat2))
                   (push (?3 incl dmns z) hat2)
                   (let ((y (funcall tot-kfll (1- dmns) (1+ dmns) hat2)))
                     (a-face4 tot-face (1+ dmns) (1+ dmns) y))))))
    #'rslt))  













         
#|                 


(cat-init)
(setf kz23 (k-zp 2 3))
(setf kz32 (k-zp 3 2))
(setf zero-twop (zero-twop kz23 kz32))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)

(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) dmns n)
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(funcall section 3 '(1))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))





(cat-init)
(setf kz2 (k-zp 0 2))
(setf kz3 (k-zp 0 3))
(setf zero-twop (zero-twop kz3 kz2))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)


(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) dmns n)
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(funcall section 3 '(1))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz31 (k-zp 3 1))
(setf zero-twop (zero-twop kz21 kz31))
(setf fib (twop-kanfibration zero-twop))

(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 2)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 2))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 2 tdegr 1)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)


;; En este ejemplo no se puede calcular la seccin porque sgroup=0
;; (setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) dmns n)
;; (setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
;; (funcall section 3 '(1))
;; (funcall bf dmns (? proj dmns (funcall section dmns '(1))))





(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)


(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) dmns n)
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(funcall section 3 '(1))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))
;;;  Ojo aqu ker=0 luego no tendra sentido definir la seccin. La defino sobre sgroup=Z
;;; Despus tendr que componer con la inclusin ker \in sgroup



                        

|#


(defun kan-fibr-retraction-aux (kffll bh ff base-kfll base-bspn base-face tot-face tot-bspn proj incl-1)
  (declare 
   )
  (flet ((rslt (dmns absm)
               (declare (type fixnum dmns)
                        (type gnrt absm))
               (let ((a (funcall bh dmns (? proj dmns absm)))
                     (hat nil)             
                     (m (mask (1+ dmns))))
                 (dotimes (i dmns)
                   (push (absm m base-bspn) hat))
                 (push a hat)
                 (push (absm m base-bspn) hat)
                 (let* ((w (funcall base-kfll (+ 2 dmns) (+ 2 dmns) hat))
                        (b (a-face4 base-face (+ 2 dmns) (+ 2 dmns) w))
                        (hat2 nil))
                   (dotimes (i dmns)
                     (push (absm m tot-bspn) hat2))
                   (push absm hat2)
                   (let* ((x (funcall kffll 0 (1+ dmns) hat2 b))
                         (del0x (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) x)))
                         )
                   (funcall ff dmns del0x))))))
    #'rslt))


(defun kan-fibr-retraction (proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr)
  (flet ((rslt (dmns absm)
               (declare (type fixnum dmns)
                        (type gnrt absm))
               (let ((j (funcall bf dmns (? proj dmns absm)))
                     (bgroup (funcall bgr dmns)))
                 (if (or (not j) (cmbn-zerop bgroup j))
                     (funcall (kan-fibr-retraction-aux kffll bh ff base-kfll base-bspn base-face tot-face bspn proj incl-1) dmns absm)
                   (let* ((absm2 (funcall (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll) dmns j))
                         (z (funcall (ksmst-sum tot-kfll tot-face bspn) dmns absm (funcall (ksmst-inv tot-kfll tot-face bspn) dmns absm2))))
                     (funcall (kan-fibr-retraction-aux kffll bh ff base-kfll base-bspn base-face tot-face bspn proj incl-1) dmns z ))
                    ))))
    #'rslt))


(defun ksmst-inv (kfll face bspn)
  (flet ((rslt (dmns absm)
               (let ((hat nil)
                     (m (mask (1+ dmns))))
                 (push (absm m bspn) hat)
                 (push absm hat)
                 (dotimes (i (1- dmns))
                   (push (absm m bspn) hat))
                 (let ((w (funcall kfll (1+ dmns) (1+ dmns) hat)))
                   (a-face4 face (1+ dmns) (1+ dmns) w)))))
    #'rslt))
                 
;;(setf inv (ksmst-inv tot-kfll tot-face bspn))
;;(funcall inv n (absm 0 gmsm))
               
               

(defun ksmst-sum (kfll face bspn)
  (flet ((rslt (dmns absm1 absm2)
               (let ((hat nil)
                     (m (mask (1+ dmns))))
                 (push absm2 hat)
                 (push absm1 hat)
                 (dotimes (i (1- dmns))
                   (push (absm m bspn) hat))
                 (let ((w (funcall kfll dmns (1+ dmns) hat)))
                   (a-face4 face dmns (1+ dmns) w)))))
    #'rslt))

;;(setf sum (ksmst-sum tot-kfll tot-face bspn))
;;(funcall sum n (absm 0 gmsm) (absm 0 gmsm))
               


         
#|                 


(cat-init)
(setf kz22 (k-zp 2 2))
(setf kz21 (k-zp 2 1))
(setf zero-twop (zero-twop kz22 kz21))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 2)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 2))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 2 tdegr 1)


(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 2)
(setf absm (funcall section 2 '(1)))
(funcall retraction dmns absm)
(funcall retraction 1 (absm 0 (first (basis tot 1))))


(setf fg (g tefhmt))

(funcall retraction (1- dmns) (? incl (1- dmns) (funcall fg (1- dmns) '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))


;; No puedo hacer la suma de la seccin ms la retraccin porque estn en dimensiones diferentes


    
    
(cat-init)
(setf kz2 (k-zp 0 2))
(setf kz3 (k-zp 0 3))
(setf zero-twop (zero-twop kz3 kz2))
(setf fib (twop-kanfibration zero-twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 3)
(setf absm (funcall section 3 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction (1- dmns) (? incl (1- dmns) (funcall fg (1- dmns) '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))

;; No puedo hacer la suma de la seccin ms la retraccin porque estn en dimensiones diferentes


(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)


(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 3)
(setf absm (funcall section 3 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction (1- dmns) (? incl (1- dmns) (funcall fg (1- dmns) '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))

;; No puedo hacer la suma de la seccin ms la retraccin porque estn en dimensiones diferentes





(cat-init)
(setf kz21 (k-zp 2 1))
(setf kz31 (k-zp 3 1))
(setf zero-twop (zero-twop kz21 kz31))
(setf fib (twop-kanfibration zero-twop))

(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))


(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 0))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)




(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns n)
(setf absm (funcall section dmns '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction dmns (? incl dmns (funcall fg dmns '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))



(setf absm (absm 0 (first (last (basis tot dmns)))))
(setf absm1 (funcall section dmns (funcall bf dmns (? proj dmns absm))))
(setf absm2 (? incl dmns (funcall fg dmns (funcall retraction dmns absm))))
(funcall (ksmst-sum tot-kfll tot-face bspn) dmns absm1 absm2)







(cat-init)
(setf a (cyclic-group 3))
(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 3))
                         (g2 (mod (first c2) 3))
                         (rslt
                          (if (< (+ g1 g2) 3) 0
                            (if (= 3 (+ g1 g2)) 1
                              1))))
                         (list rslt))))

(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))

(dotimes (i (length (basis tot dmns)))
  (let* ((absm (absm 0 (nth i (basis tot dmns))))
         (absm1 (funcall section dmns (funcall bf dmns (? proj dmns absm))))
         (absm2 (? incl dmns (funcall fg dmns (funcall retraction dmns absm)))))
    (progn
      (print absm)
      (print absm1)
      (print absm2)
      (print (funcall (ksmst-sum tot-kfll tot-face bspn) dmns absm1 absm2)))))
    


                      

|#



(defun kan-fibr-cocycle (dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr)
  (flet ((rslt (c1 c2)
               (declare 
                 (type list c1 c2))
               (let* ((section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (inv (ksmst-inv tot-kfll tot-face bspn))
                      (sum (ksmst-sum tot-kfll tot-face bspn))
                      (c1+c2 (mapcar #'(lambda (i)
                                         (+ (nth i c1) (nth i c2)))
                               (<a-b< 0 (length c1))))
                      (absm1 (funcall section dmns c1))
                      (absm2 (funcall section dmns c2))
                      (absm3 (funcall section dmns c1+c2))
                      (-absm3 (funcall inv dmns absm3)))
                 (funcall retraction dmns (funcall sum dmns (funcall sum dmns absm1 absm2) -absm3)))))
    #'rslt))


(defun fngnabgr-cocycle-fibration (fngnabgr1 fngnabgr2 cocycle-intr)
   (declare
    (type function cocycle))
   (build-smmr :sorc (k-g-1 fngnabgr1) :trgt (k-g-1 fngnabgr2) :degr -1 :sintr (cocycle-fibration-intr (fngnabgr-to-group fngnabgr1) (fngnabgr-to-group fngnabgr2) cocycle-intr)
               :orgn  `(central extension fibration for the cocycle ,cocycle-intr)))



#|

(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 3)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 3))
(setf tgroup (funcall (gr tefhmt) 2))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 3 tdegr 2)
(setf mrph (intr-to-group-mrph sgroup tgroup sg tf intr sdegr tdegr))

(kernel mrph)
(cokernel mrph)


(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 3)
(setf absm (funcall section 3 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction (1- dmns) (? incl (1- dmns) (funcall fg (1- dmns) '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))


(setf c1 '(1) c2 '(2))
(setf cocycle (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))
(funcall cocycle c1 c2)









(cat-init)
(setf a (cyclic-group 3))
(setf cocycle #'(lambda (c1 c2)
                  (let* ((g1 (mod (first c1) 3))
                         (g2 (mod (first c2) 3))
                         (rslt
                          (if (< (+ g1 g2) 3) 0
                            (if (= 3 (+ g1 g2)) 1
                              1))))
                         (list rslt))))

(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(setf cocycle2 (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))

(funcall cocycle '(2) '(1))
(funcall cocycle2  '(1) '(2))
(funcall cocycle '(0) '(0))
(funcall cocycle2  '(0) '(0))
(setf e (central-extension sgroup tgroup cocycle))
(divisors (first e))
(setf e2 (central-extension sgroup tgroup cocycle2))
(divisors (first e2))




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(setf cocycle2 (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))

(funcall cocycle '(2) '(1))
(funcall cocycle2  '(1) '(2))
(funcall cocycle '(0) '(0))
(funcall cocycle2  '(0) '(0))
(setf e (central-extension sgroup tgroup cocycle))
(divisors (first e))
(setf e2 (central-extension sgroup tgroup cocycle2))
(divisors (first e2))



(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 2
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(setf cocycle2 (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))

(funcall cocycle '(2) '(1))
(funcall cocycle2  '(1) '(2))
(funcall cocycle '(0) '(0))
(funcall cocycle2  '(0) '(0))
(setf e (central-extension sgroup tgroup cocycle))
(divisors (first e))
(setf e2 (central-extension sgroup tgroup cocycle2))
(divisors (first e2))



(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 3
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(setf cocycle2 (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))

(funcall cocycle '(2) '(1))
(funcall cocycle2  '(1) '(2))
(funcall cocycle '(0) '(0))
(funcall cocycle2  '(0) '(0))
(setf e (central-extension sgroup tgroup cocycle))
(divisors (first e))
(setf e2 (central-extension sgroup tgroup cocycle2))
(divisors (first e2))





(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 0
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))
(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf base (trgt proj))
(setf fiber (sorc incl))
(setf tot (trgt incl))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf incl-1 (incl-11 fib))

(setf n 1)
(setf intr (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face n))


(setf sefhmt (efhmt1 base))
(setf tefhmt (efhmt1 fiber))
(setf sgroup (funcall (gr sefhmt) 1))
(setf tgroup (funcall (gr tefhmt) 1))
(setf sg (g sefhmt))
(setf tf (f tefhmt))
(setf sdegr 1 tdegr 0)



(setf bg sg bf (f sefhmt) fh (h tefhmt) tot-kfll (kfll tot) bgr (gr sefhmt))
(setf section (kan-fibr-section kffll incl incl-1 bspn tot-face sg fh tot-kfll))
(setf bh (h sefhmt) ff (f tefhmt) base-kfll (kfll base) base-bspn (bspn base) base-face (face base) )
(setf retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
(setf dmns 1)
(setf absm (funcall section 1 '(1)))
(funcall retraction dmns absm)


(setf fg (g tefhmt))

(funcall retraction 1 (? incl 1 (funcall fg 1 '(1))))
(funcall bf dmns (? proj dmns (funcall section dmns '(1))))




(setf cocycle2 (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face))


(setf e (central-extension tgroup sgroup cocycle))
(divisors (first e))
(setf e2 (central-extension sgroup tgroup cocycle2))
(divisors (first e2))





|#




(defun kfbr-tot-efhmt-gr (fib )
  (flet ((rslt (dmns)
               (let* ((kffll (kffll fib))
                      (incl (incl1 fib))
                      (proj (fibr1 fib))
                      (base (trgt proj))
                      (fiber (sorc incl))
                      (tot (trgt incl))
                      (bspn (bspn tot))
                      (tot-face (face tot))
                      (incl-1 (incl-11 fib))
                      (befhmt (efhmt1 base))
                      (fefhmt (efhmt1 fiber))
                      (bf (f befhmt))
                      (bg (g befhmt))
                      (bh (h befhmt))
                      (ff (f fefhmt))
                      (fg (g fefhmt))
                      (fh (h fefhmt))
                      (tot-kfll (kfll tot))
                      (base-kfll (kfll base))
                      (base-bspn (bspn base))
                      (base-face (face base))
                      (bgr (gr befhmt))
                      (bgroup-dmns (funcall (gr befhmt) dmns))
                      (fgroup-dmns (funcall (gr fefhmt) dmns))
                      (bgroup-dmns+1 (funcall (gr befhmt) (1+ dmns)))
                      (fgroup-dmns-1 (funcall (gr fefhmt) (1- dmns)))
                      (section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      
                      (cnmrph-intr-dmns (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face dmns))
                      (cnmrph-intr-dmns+1 (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face (1+ dmns)))
                      (cnmrph-dmns (intr-to-group-mrph bgroup-dmns fgroup-dmns-1 bg ff cnmrph-intr-dmns dmns (1- dmns)))
                      (cnmrph-dmns+1 (intr-to-group-mrph bgroup-dmns+1 fgroup-dmns bg ff cnmrph-intr-dmns+1 (1+ dmns) dmns))
                      (kernel (kernel cnmrph-dmns))
                      (cokernel (cokernel cnmrph-dmns+1))
                      (sgroup (first kernel))
                      (tgroup (first cokernel))
                      (cocycle-aux (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      )
                 (flet ((cocycle (c1 c2)
                                 (let* ((aux (second kernel))
                                        (aux2 (second cokernel))
                                        (g1 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c1))) 1))
                                        (g2 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c2))) 1))
                                        (rslt (funcall cocycle-aux g1 g2)))
                                   (column-j (mtrx-prdc aux2 (Gnrt-List-to-Mtrx (list rslt))) 1))))
                   (first (central-extension tgroup sgroup #'cocycle))))))
    #'rslt))



#|

(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 0
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 2
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 3
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))








(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))


(central-extension tgroup sgroup cocycle)


|#
   


(defun kfbr-tot-efhmt-f (fib )
  (flet ((rslt (dmns absm)
               (declare (type fixnum dmns)
                        (type absm absm))
               (let* ((kffll (kffll fib))
                      (incl (incl1 fib))
                      (proj (fibr1 fib))
                      (base (trgt proj))
                      (fiber (sorc incl))
                      (tot (trgt incl))
                      (bspn (bspn tot))
                      (tot-face (face tot))
                      (incl-1 (incl-11 fib))
                      (befhmt (efhmt1 base))
                      (fefhmt (efhmt1 fiber))
                      (bf (f befhmt))
                      (bg (g befhmt))
                      (bh (h befhmt))
                      (ff (f fefhmt))
                      (fg (g fefhmt))
                      (fh (h fefhmt))
                      (bgr (gr befhmt))
                      (tot-kfll (kfll tot))
                      (base-kfll (kfll base))
                      (base-bspn (bspn base))
                      (base-face (face base))
                      (section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      
                      (bgroup-dmns (funcall (gr befhmt) dmns))
                      (fgroup-dmns (funcall (gr fefhmt) dmns))
                      (bgroup-dmns+1 (funcall (gr befhmt) (1+ dmns)))
                      (fgroup-dmns-1 (funcall (gr fefhmt) (1- dmns)))

                      (cnmrph-intr-dmns (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face dmns))
                      (cnmrph-intr-dmns+1 (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face (1+ dmns)))
                      (cnmrph-dmns (intr-to-group-mrph bgroup-dmns fgroup-dmns-1 bg ff cnmrph-intr-dmns dmns (1- dmns)))
                      (cnmrph-dmns+1 (intr-to-group-mrph bgroup-dmns+1 fgroup-dmns bg ff cnmrph-intr-dmns+1 (1+ dmns) dmns))
                      (kernel (kernel cnmrph-dmns))
                      (cokernel (cokernel cnmrph-dmns+1))
                      (sgroup (first kernel))
                      (tgroup (first cokernel))
                      (cocycle-aux (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (cen-ext (flet ((cocycle (c1 c2)
                                 (let* ((aux (second kernel))
                                        (aux2 (second cokernel))
                                        (g1 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c1))) 1))
                                        (g2 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c2))) 1))
                                        (rslt (funcall cocycle-aux g1 g2)))
                                   (column-j (mtrx-prdc aux2 (Gnrt-List-to-Mtrx (list rslt))) 1))))
                                 (central-extension tgroup sgroup #'cocycle))))
                 (if (= 0 (nlig (mtrx (first cen-ext)))  )
                     nil
                   (let* ((j (kernel-element-image cnmrph-dmns (funcall bf dmns (? proj dmns absm))))
                      (rho (column-j (mtrx-prdc (second cokernel) (gnrt-list-to-mtrx (list (funcall retraction dmns absm)))) 1))
                      (pair (nconc rho j)))
                 (column-j (mtrx-prdc (third cen-ext) (gnrt-list-to-mtrx (list pair))) 1))))))
                 
    #'rslt))






(defun kfbr-tot-efhmt-g (fib )
  (flet ((rslt (dmns el)
               (declare (type fixnum dmns)
                        (type list el))
               (let* ((kffll (kffll fib))
                      (incl (incl1 fib))
                      (proj (fibr1 fib))
                      (base (trgt proj))
                      (fiber (sorc incl))
                      (tot (trgt incl))
                      (bspn (bspn tot))
                      (tot-face (face tot))
                      (incl-1 (incl-11 fib))
                      (befhmt (efhmt1 base))
                      (fefhmt (efhmt1 fiber))
                      (bf (f befhmt))
                      (bg (g befhmt))
                      (bh (h befhmt))
                      (ff (f fefhmt))
                      (fg (g fefhmt))
                      (fh (h fefhmt))
                      (bgr (gr befhmt))
                      (tot-kfll (kfll tot))
                      (base-kfll (kfll base))
                      (base-bspn (bspn base))
                      (base-face (face base))
                      (section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (sum (ksmst-sum tot-kfll tot-face bspn))
                      (bgroup-dmns (funcall (gr befhmt) dmns))
                      (fgroup-dmns (funcall (gr fefhmt) dmns))
                      (bgroup-dmns+1 (funcall (gr befhmt) (1+ dmns)))
                      (fgroup-dmns-1 (funcall (gr fefhmt) (1- dmns)))

                      (cnmrph-intr-dmns (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face dmns))
                      (cnmrph-intr-dmns+1 (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face (1+ dmns)))
                      (cnmrph-dmns (intr-to-group-mrph bgroup-dmns fgroup-dmns-1 bg ff cnmrph-intr-dmns dmns (1- dmns)))
                      (cnmrph-dmns+1 (intr-to-group-mrph bgroup-dmns+1 fgroup-dmns bg ff cnmrph-intr-dmns+1 (1+ dmns) dmns))
                      (kernel (kernel cnmrph-dmns))
                      (cokernel (cokernel cnmrph-dmns+1))
                      (sgroup (first kernel))
                      (tgroup (first cokernel))
                      (cocycle-aux (kan-fibr-cocycle dmns proj base bf bh ff base-kfll base-bspn tot-face kffll incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (cen-ext (flet ((cocycle (c1 c2)
                                 (let* ((aux (second kernel))
                                        (aux2 (second cokernel))
                                        (g1 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c1))) 1))
                                        (g2 (column-j (mtrx-prdc aux (Gnrt-List-to-Mtrx (list c2))) 1))
                                        (rslt (funcall cocycle-aux g1 g2)))
                                   (column-j  (mtrx-prdc aux2 (Gnrt-List-to-Mtrx (list rslt))) 1))))
                                 (central-extension tgroup sgroup #'cocycle)))
                      (ck (column-j (mtrx-prdc (second cen-ext) (gnrt-list-to-mtrx (list el))) 1))
                      (c (subseq ck 0 (nlig (mtrx (first cokernel)))))
                      (k (subseq ck (nlig (mtrx (first cokernel))) (length ck)))
                      
                      (absm1 (if c 
                                 (?3 incl dmns (funcall fg dmns (column-j (mtrx-prdc (third cokernel) (gnrt-list-to-mtrx (list c))) 1)))
                               (absm (1- (expt 2 dmns)) bspn)))
                      (absm2 (if k
                                 (funcall section dmns (column-j (mtrx-prdc (second kernel) (Gnrt-List-to-Mtrx (list k))) 1))
                               (absm (1- (expt 2 dmns)) bspn))))
                 (funcall sum dmns absm1 absm2))))
    #'rslt))


#|



(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 0
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))


(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)
(setf absm (absm 1 (bspn (sorc (fibr1 fib)))))
(funcall efhmt-f 1 absm)

(basis (sorc (fibr1 fib)) 2)
(setf absm (absm 0 (nth 5 *)))
(funcall efhmt-f 2 absm)


(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))



(setf absm (funcall efhmt-g 1 '(1)))
(funcall efhmt-f 1 absm)
(basis (sorc (fibr1 fib)) 2)
(setf absm (absm 0 (nth 5 *)))
(funcall efhmt-f 2 absm)





(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 2
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))

(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)
(basis (sorc (fibr1 fib)) 2)
(setf absm (absm 0 (nth 8 *)))
(funcall efhmt-f 2 absm)




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 3
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))

(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(2 4)))
(funcall efhmt-f 1 absm)

(basis (sorc (fibr1 fib)) 2)
(setf absm (absm 0 (nth 8 *)))
(funcall efhmt-f 2 absm)
(basis (sorc (fibr1 fib)) 3)
(setf absm (absm 0 (nth 8 *)))
(funcall efhmt-f 2 absm)



(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))

(setf absm (funcall efhmt-g 2 '(1)))
(funcall efhmt-f 2 absm)


(setf absm (funcall efhmt-g 2 '(2)))
(funcall efhmt-f 2 absm)





|#




(defun kfbr-tot-efhmt-h (fib )
  (flet ((rslt (dmns absm)
               (declare (type fixnum dmns)
                        (type absm absm))
               (let* ((kffll (kffll fib))
                      (incl (incl1 fib))
                      (proj (fibr1 fib))
                      (base (trgt proj))
                      (fiber (sorc incl))
                      (tot (trgt incl))
                      (bspn (bspn tot))
                      (tot-face (face tot))
                      (incl-1 (incl-11 fib))
                      (befhmt (efhmt1 base))
                      (fefhmt (efhmt1 fiber))
                      (bf (f befhmt))
                      (bg (g befhmt))
                      (bh (h befhmt))
                      (ff (f fefhmt))
                      (fg (g fefhmt))
                      (fh (h fefhmt))
                      (bgr (gr befhmt))
                      (tot-kfll (kfll tot))
                      (base-kfll (kfll base))
                      (base-bspn (bspn base))
                      (base-face (face base))
                      (fiber-kfll (kfll fiber))
                      (fiber-bspn (bspn fiber))
                      (fiber-face (face fiber))
                      ;;(section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll
                                                       incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (sum (ksmst-sum tot-kfll tot-face bspn))
                      (fsum (ksmst-sum fiber-kfll fiber-face fiber-bspn))
                      (inv (ksmst-inv tot-kfll tot-face bspn))
                      (finv (ksmst-inv fiber-kfll fiber-face fiber-bspn))
                      ;;(bgroup-dmns (funcall (gr befhmt) dmns))
                      (fgroup-dmns (funcall (gr fefhmt) dmns))
                      (bgroup-dmns+1 (funcall (gr befhmt) (1+ dmns)))
                      ;;(fgroup-dmns-1 (funcall (gr fefhmt) (1- dmns)))

                      ;;(cnmrph-intr-dmns (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face dmns))
                      (cnmrph-intr-dmns+1 (kan-fibr-cnmrph-intr kffll incl-1 bspn tot-face (1+ dmns)))
                      ;;(cnmrph-dmns (intr-to-group-mrph bgroup-dmns fgroup-dmns-1 bg ff cnmrph-intr-dmns dmns (1- dmns)))
                      (cnmrph-dmns+1 (intr-to-group-mrph bgroup-dmns+1 fgroup-dmns bg ff cnmrph-intr-dmns+1 (1+ dmns) dmns))
                      (x 
                       (let ((a (funcall bh dmns (? proj dmns absm)))
                               (hat nil)             
                               (m (mask (1+ dmns))))
                           (dotimes (i dmns)
                             (push (absm m base-bspn) hat))
                           (push a hat)
                           (push (absm m base-bspn) hat)
                           (let* ((w (funcall base-kfll (+ 2 dmns) (+ 2 dmns) hat))
                                  (b (a-face4 base-face (+ 2 dmns) (+ 2 dmns) w))
                                  (hat2 nil))
                             (dotimes (i dmns)
                               (push (absm m bspn) hat2))
                             (push absm hat2)
                             (funcall kffll 0 (1+ dmns) hat2 b))))
                      (del0x (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) x)))
                      (r (funcall ff dmns del0x))
                      (beta (mrph-element-preimage cnmrph-dmns+1 r))
                      (v (funcall bg (1+ dmns) beta))
                      (w 
                       (let ((hat nil)
                             (m (mask (1+ dmns))))
                         (dotimes (i (1+ dmns))
                           (push (absm m bspn) hat))
                         (funcall kffll 0 (1+ dmns) hat v)))
                      (del0w
                           (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) w)))
                      
                      (del0w-del0x (funcall fsum dmns del0w (funcall finv dmns del0x)))
                      (a (funcall fh dmns del0w-del0x))
                      (s (funcall (2elements-homotopy fiber-kfll fiber-face fiber-bspn) dmns del0x del0w a)))

                      
                      (let ((hat nil)             
                            (m (mask (1+ dmns))))
                        (push x hat)
                        (push w hat)
                        (dotimes (i (1- dmns))
                          (push (absm m bspn) hat))
                        (push (?3 incl (1+ dmns) s) hat)
                        (let ((y (funcall tot-kfll 1 (+ 2 dmns) hat)))
                          (a-face4 tot-face 1 (+ 2 dmns) y)))
                        
                 )))
               #'rslt))

                   
#|                 
(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))
(setf efhmt-h (kfbr-tot-efhmt-h fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))

(setf absm (funcall efhmt-g 2 '(1)))
(funcall efhmt-f 2 absm)



(setf absm (funcall efhmt-g 2 '(2)))
(funcall efhmt-f 2 absm)


  (setf absm (funcall efhmt-g 2 '(3)))
(funcall efhmt-f 2 absm)
(funcall efhmt-g 2 *)
(setf h (funcall efhmt-h 2 absm)  )




(setf dmns 2)
(dotimes (i 4)
  (print (face (sorc (fibr1 fib)) i (1+ dmns) h)))




(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 0
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))
(setf efhmt-h (kfbr-tot-efhmt-h fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))


(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(6 6)))
(funcall efhmt-f 1 absm)
(setf h (funcall efhmt-h 1 absm))
(setf dmns 1)
(dotimes (i 3)
  (print (face (sorc (fibr1 fib)) i (1+ dmns) h)))





(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))
(setf efhmt-h (kfbr-tot-efhmt-h fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))



(setf absm (funcall efhmt-g 1 '(1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(36)))
(funcall efhmt-f 1 absm)
(setf h (funcall efhmt-h 1 absm))
(setf dmns 1)
(dotimes (i 3)
  (print (face (sorc (fibr1 fib)) i (1+ dmns) h)))







(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 2
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))
(setf efhmt-h (kfbr-tot-efhmt-h fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))

(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)

(setf absm (funcall efhmt-g 1 '(0 0)))
(funcall efhmt-f 1 absm)
(setf h (funcall efhmt-h 1 absm))
(setf dmns 1)
(dotimes (i 3)
  (print (face (sorc (fibr1 fib)) i (1+ dmns) h)))






(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 3
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-group fib))
(setf efhmt-f (kfbr-tot-efhmt-f fib))
(setf efhmt-g (kfbr-tot-efhmt-g fib))
(setf efhmt-h (kfbr-tot-efhmt-h fib))

(divisors (first (funcall efhmt-gr 1)))
(divisors (first (funcall efhmt-gr 2)))
(divisors (first (funcall efhmt-gr 3)))

(setf absm (funcall efhmt-g 1 '(0 1)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(1 0)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(2 4)))
(funcall efhmt-f 1 absm)
(setf absm (funcall efhmt-g 1 '(0 0)))
(funcall efhmt-f 1 absm)
(setf h (funcall efhmt-h 1 absm))
(setf dmns 1)
(dotimes (i 3)
  (print (face (sorc (fibr1 fib)) i (1+ dmns) h)))


|#



(defun kfbr-tot-efhmt (fib )
  (print 'hola)
  (build-efhmt :gr (kfbr-tot-efhmt-gr fib ) :f (kfbr-tot-efhmt-f fib ) :g (kfbr-tot-efhmt-g fib ) :h 
               (kfbr-tot-efhmt-h fib ) :orgn   `(Effective homotopy of the total space of ,fib))
  )





(defun kfbr-tot-kfll (fib)
  (let* ((fibr (fibr1 fib))
         (kffll (kffll fib))
         (bkfll (kfll (trgt fibr))))
    (flet ((rslt (indx dmns hat 
                       &aux (dmns-1 (1- dmns)))
                 (declare
                  (type fixnum indx dmns dmns-1)
                  (list hat)
                  )
                 (the absm
                   (let* ((hat2 
                           (mapcar #'(lambda (xi)
                                       (? fibr dmns-1 xi))
                             hat))
                          (b (funcall bkfll indx dmns hat2)))
                     (funcall kffll indx dmns hat b))))) 
      (the kfll #'rslt))))







#|

(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib1 (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib1))
(setf efhmt-f (kfbr-tot-efhmt-f fib1))
(setf efhmt-g (kfbr-tot-efhmt-g fib1))
(setf efhmt-h (kfbr-tot-efhmt-h fib1))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))

(setf absm (funcall efhmt-g 2 '(1)))
(funcall efhmt-f 2 absm)



(setf absm (funcall efhmt-g 2 '(2)))
(funcall efhmt-f 2 absm)


  (setf absm (funcall efhmt-g 2 '(3)))
(funcall efhmt-f 2 absm)
(setf h (funcall efhmt-h 2 absm)  )

(funcall efhmt-f 2 (absm 1 (bspn (sorc (fibr1 fib1)))))




(setf dmns 2)
(dotimes (i 4)
  (print (face (sorc (fibr1 fib1)) i (1+ dmns) h)))



(crts-prdc-to-smgr (trgt (fibr1 fib1)) (sorc (incl1 fib1)) (sorc (fibr1 fib1)))
(abSMGR-TO-EFHMT (sorc (fibr1 fib1)) (kfbr-tot-efhmt fib1))
(homotopy-group (sorc (fibr1 fib1)) 2)

(setf zero-twop (zero-twop (sorc (fibr1 fib1)) (k-zp 3 2)))
(setf fib2 (twop-kanfibration zero-twop))
(crts-prdc-to-smgr (trgt (fibr1 fib2)) (sorc (incl1 fib2)) (sorc (fibr1 fib2)))

(abSMGR-TO-EFHMT (sorc (fibr1 fib2)) (kfbr-tot-efhmt fib2))


(homotopy-group (sorc (fibr1 fib2)) 1)
(homotopy-group (sorc (fibr1 fib2)) 2)
(homotopy-group (sorc (fibr1 fib2)) 3)
(funcall (f (efhmt1 (sorc (fibr1 fib2)))) 2 (absm 3 (bspn (sorc (fibr1 fib2)))))



(setf zero-twop2 (zero-twop (sorc (fibr1 fib2)) (k-zp 6 1)))
(setf fib3 (twop-kanfibration zero-twop2))
(crts-prdc-to-smgr (trgt (fibr1 fib3)) (sorc (incl1 fib3)) (sorc (fibr1 fib3)))
(abSMGR-TO-EFHMT (sorc (fibr1 fib3)) (kfbr-tot-efhmt fib3))


(homotopy-group (sorc (fibr1 fib3)) 1)
(homotopy-group (sorc (fibr1 fib3)) 2)
(homotopy-group (sorc (fibr1 fib3)) 3)



(funcall (f (efhmt1 (sorc (fibr1 fib3)))) 1 (absm 1 (bspn (sorc (fibr1 fib3)))))




(setf zero-twop3 (zero-twop (sorc (fibr1 fib3)) (k-zp 6 1)))
(setf fib4 (twop-kanfibration zero-twop3))
(crts-prdc-to-smgr (trgt (fibr1 fib4)) (sorc (incl1 fib4)) (sorc (fibr1 fib4)))
(abSMGR-TO-EFHMT (sorc (fibr1 fib4)) (kfbr-tot-efhmt fib4))


(homotopy-group (sorc (fibr1 fib4)) 1)
(homotopy-group (sorc (fibr1 fib4)) 2)
(homotopy-group (sorc (fibr1 fib4)) 3)




|#




#|

(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib1 (twop-kanfibration twop))

(setf efhmt-gr (kfbr-tot-efhmt-gr fib1))
(setf efhmt-f (kfbr-tot-efhmt-f fib1))
(setf efhmt-g (kfbr-tot-efhmt-g fib1))
(setf efhmt-h (kfbr-tot-efhmt-h fib1))

(divisors (funcall efhmt-gr 1))
(divisors (funcall efhmt-gr 2))
(divisors (funcall efhmt-gr 3))

(funcall efhmt-h 1 (absm 1 (bspn (sorc (fibr1 fib1)))))



(SMST-WITH-EFHMT (sorc (fibr1 fib1)) (kfbr-tot-kfll fib1) (kfbr-tot-efhmt fib1))
(homotopy-group (sorc (fibr1 fib1)) 2)

(setf fiber (sorc (incl1 fib1)) 
  base (trgt (fibr1 fib1))
  tot (sorc (fibr1 fib1)))



(setf zero-twop2 (zero-twop (sorc (fibr1 fib1)) (k-zp 3 2)))
(setf fib3 (twop-kanfibration zero-twop2))
(SMST-WITH-EFHMT (sorc (fibr1 fib3)) (kfbr-tot-kfll fib3) (kfbr-tot-efhmt fib3))


(homotopy-group (sorc (fibr1 fib3)) 1)
(homotopy-group (sorc (fibr1 fib3)) 2)
(homotopy-group (sorc (fibr1 fib3)) 3)



(funcall (f (efhmt1 (sorc (fibr1 fib3)))) 1 (absm 1 (bspn (sorc (fibr1 fib3))))) 



(setf zero-twop3 (zero-twop (sorc (fibr1 fib3)) (k-zp 6 1)))
(setf fib4 (twop-kanfibration zero-twop3))
(SMST-WITH-EFHMT (sorc (fibr1 fib4)) (kfbr-tot-kfll fib4) (kfbr-tot-efhmt fib4))



(homotopy-group (sorc (fibr1 fib4)) 1)
(homotopy-group (sorc (fibr1 fib4)) 2)
(homotopy-group (sorc (fibr1 fib4)) 3)


(setf zero-twop4 (zero-twop (sorc (fibr1 fib4)) (k-zp 2 1)))
(setf fib5 (twop-kanfibration zero-twop4))
(SMST-WITH-EFHMT (sorc (fibr1 fib5)) (kfbr-tot-kfll fib5) (kfbr-tot-efhmt fib5))



(homotopy-group (sorc (fibr1 fib5)) 1)
(homotopy-group (sorc (fibr1 fib5)) 2)
(homotopy-group (sorc (fibr1 fib5)) 3)






|#



(DEFMETHOD SLOT-UNBOUND (class (smst KAN-WITH-EFHMT) (slot-name (eql 'kfll)))
   (declare (ignore class))
   (the kfll
     (let ((kfll (search-kfll smst (first (orgn smst)))))
       (setf (slot-value smst 'kfll)
	     (or kfll
          (error "I don't know how to determine ~
                         a fan filling for 
                         ~A (Origin: ~A)." smst (orgn smst)))))))



(DEFMETHOD SLOT-UNBOUND (class (smst KAN-WITH-EFHMT) (slot-name (eql 'efhmt)))
   (declare (ignore class))
   (the effective-homotopy
     (let ((efhmt (search-efhmt smst (first (orgn smst)))))
       (setf (slot-value smst 'efhmt) 
	     (or efhmt
          (error "I don't know how to determine ~
                         an effective homotopy for 
                         ~A (Origin: ~A)." smst (orgn smst)))))))


(DEFGENERIC SEARCH-kfll (smst orgn))

(DEFMETHOD SEARCH-kfll (smst orgn)
  (declare (ignore smst orgn))
  nil)

(DEFGENERIC SEARCH-efhmt (smst orgn))

(DEFMETHOD SEARCH-efhmt (smst orgn)
  (declare (ignore smst orgn))
  nil)

(DEFMETHOD SEARCH-kfll (smst (orgn (eql 'FIBRATION-TOTAL)))
  (declare
     (type KAN-WITH-EFHMT smst))
  (the kfll
    (let* ((twop (second (orgn smst)))
           (fibr (twop-kanfibration twop)))
      (kfbr-tot-kfll fibr))))
      
    
(DEFMETHOD SEARCH-efhmt (smst (orgn (eql 'FIBRATION-TOTAL)))
  (declare
   (type KAN-WITH-EFHMT smst))
  (the effective-homotopy
    (let* ((twop (second (orgn smst)))
           (fibr (twop-kanfibration twop)))
      (kfbr-tot-efhmt fibr ))))






(defun kan-fibr-cnmrph-intr (fib dmns)
  (declare (type kan-fibration fibr)
           (fixnum dmns))
  (let* ((kffll (kffll fib))
        (incl (incl1 fib))
        (incl-1 (incl-11 fib))
        (tot (trgt incl))
        (bspn (bspn tot))
        (tot-face (face tot))
        (tot-kfll (kfll tot)))
    (flet ((rslt (absm)
                 (let ((hat nil)
                       (m (mask dmns)))
                   (dotimes (i dmns)
                     (push (absm m bspn) hat))
                   (let ((x (funcall kffll 0 dmns hat absm)))
                     (?3 incl-1 (1- dmns) (a-face4 tot-face 0 dmns x))))))
      (the function #'rslt))))

(defun kan-fibr-cnmrph (fib dmns)
  (let* ((incl (incl1 fib))
        (fibr (fibr1 fib))
        (fiber (sorc incl))
        (tot (trgt incl))
         (base (trgt fibr))
         (fefhmt (efhmt1 fiber))
         (befhmt (efhmt1 base)))
    (unless (and (slot-boundp fiber 'efhmt) (slot-boundp base 'efhmt))
      (error "In kan-fibr-cnmrph, one of the required efhmt slots is missing."))
    (let* ((sorc (funcall befhmt dmns))
           (trgt (funcall fefhmt (1- dmns))))
      (build-esg-mrph :sorc sorc :trgt trgt :intr (kan-fibr-cnmrph-intr fib dmns)
                      :orgn `(Connection morphism of ,fib in dimension ,dmns)))))


#|
(setf mrph2 (kan-fibr-cnmrph fib 2))
(setf mrph1 (kan-fibr-cnmrph fib 1))
(divisors (gr (sorc mrph1)))
(divisors (gr (trgt mrph1)))
(divisors (gr (sorc mrph2)))
(divisors (gr (trgt mrph2)))


(divisors (gr (esg-mrph-cokernel mrph2)))
(divisors (gr (esg-mrph-kernel mrph1)))
|#



(defun kan-fibr-sg-proj (fib dmns)
  (let* ((incl (incl1 fib))
         (fibr (fibr1 fib))
         (fiber (sorc incl))
         (tot (trgt incl))
         (base (trgt fibr))
         (fefhmt (efhmt1 fiber))
         (befhmt (efhmt1 base)))
    (unless (and (slot-boundp fiber 'efhmt) (slot-boundp base 'efhmt))
      (error "In kan-fibr-sg-proj, one of the required efhmt slots is missing."))
    (let* ((cnmrph (kan-fibr-cnmrph fib dmns))
           (kernel (esg-mrph-kernel cnmrph))
           (sorc (kan-sg tot dmns)))
      (build-sg-mrph :sorc sorc :trgt kernel :intr #'(lambda (absm)
                                                        (?3 fibr dmns absm))
                      :orgn `(Projection of ,fib in dimension ,dmns)))))
  
  
  
  (defun kan-fibr-sg-incl (fib dmns)
    (let* ((incl (incl1 fib))
           (fibr (fibr1 fib))
           (fiber (sorc incl))
           (tot (trgt incl))
           (base (trgt fibr))
           (fefhmt (efhmt1 fiber))
         (befhmt (efhmt1 base)))
    (unless (and (slot-boundp fiber 'efhmt) (slot-boundp base 'efhmt))
      (error "In kan-fibr-sg-incl, one of the required efhmt slots is missing."))
    (let* ((cnmrph (kan-fibr-cnmrph fib (1+ dmns)))
           (cokernel (esg-mrph-cokernel cnmrph))
           (trgt (kan-sg tot dmns)))
      (build-sg-mrph :sorc cokernel :trgt trgt :intr #'(lambda (absm)
                                                        (?3 incl dmns absm))
                      :orgn `(Inclusion of ,fib in dimension ,dmns)))))
  
  
  
  
  



(defun kan-fibr-section-intr (fib dmns)
  (declare (type kan-fibration fib)
           (fixnum dmns))
  (let* ((kffll (kffll fib))
        (incl (incl1 fib))
        (incl-1 (incl-11 fib))
         (tot (trgt incl))
         (fiber (sorc incl))
        (bspn (bspn tot))
        (tot-face (face tot))
        (tot-kfll (kfll tot)))
    (flet ((rslt (b)
                 (let ((hat nil)
                       (m (mask dmns))
                       )
                 (dotimes (i dmns)
                   (push (absm m bspn) hat))
                 (let* ((x (funcall kffll 0 dmns hat b))
                        (del0x (?3 incl-1 (1- dmns) (a-face4 tot-face 0 dmns x)))
                        (z (funcall (h (funcall (efhmt1 fiber) (1- dmns))) del0x))
                        (hat2 nil))
                   (push x hat2)
                   (dotimes (i (1- dmns))
                     (push (absm m bspn) hat2))
                   (push (?3 incl dmns z) hat2)
                   (let ((y (funcall tot-kfll (1- dmns) (1+ dmns) hat2)))
                     (a-face4 tot-face (1+ dmns) (1+ dmns) y))))))
      (the function #'rslt))))

(defun kan-sg (ss dmns)
  (build-sg  
   :cmps (kfll-cmps (kfll ss) (face ss) (bspn ss) dmns)
   :inv (kfll-inv (kfll ss) (face ss) (bspn ss) dmns)
   :nullel (absm (mask dmns) (bspn ss))
   :orgn `(Setoid-group2 of ,ss in dimension ,dmns)))


;;; No s si tiene sentido porque la seccin es solo set-theoretic ??
(defun kan-fibr-section (fib dmns)
  (let* ((fibr (fibr1 fib))
         (fiber (sorc incl))
         (tot (trgt incl))
         (base (trgt fibr)))
    (unless (and (slot-boundp fiber 'efhmt) (slot-boundp base 'efhmt))
      (error "In kan-fibr-section, one of the required efhmt slots is missing."))
    (let* ((cnmrph (kan-fibr-cnmrph fib dmns))
           (kernel (esg-mrph-kernel cnmrph))
           (trgt (kan-sg tot dmns)))
      (build-sg-mrph :sorc kernel :trgt trgt :intr (kan-fibr-section-intr fib dmns)
                      :orgn `(Section2 of ,fib in dimension ,dmns)))))



#|

(setf section (kan-fibr-section fib 1))


|#





(defun kan-fibr-retraction-aux-intr (fib dmns)
  (let* ((kffll (kffll fib))
         (incl (incl1 fib))
         (fibr (fibr1 fib))
         (incl-1 (incl-11 fib))
         (tot (trgt incl))
         (base (trgt fibr))
         (base-kfll (kfll base))
         (base-bspn (bspn base))
         (base-face (face base))
         (tot-bspn (bspn tot))
         (tot-face (face tot)))


  (flet ((rslt (absm)
               (declare 
                        (type gnrt absm))
               (let ((a (funcall (h (funcall (efhmt1 base) dmns)) (? fibr dmns absm)))
                     (hat nil)             
                     (m (mask (1+ dmns))))
                 (dotimes (i dmns)
                   (push (absm m base-bspn) hat))
                 (push a hat)
                 (push (absm m base-bspn) hat)
                 (let* ((w (funcall base-kfll (+ 2 dmns) (+ 2 dmns) hat))
                        (b (a-face4 base-face (+ 2 dmns) (+ 2 dmns) w))
                        (hat2 nil))
                   (dotimes (i dmns)
                     (push (absm m tot-bspn) hat2))
                   (push absm hat2)
                   (let* ((x (funcall kffll 0 (1+ dmns) hat2 b))
                          )
                     (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) x))
                     )))))
    #'rslt)))


(defun kan-fibr-retraction-intr (fib dmns)
  (let* ((kffll (kffll fib))
         (incl (incl1 fib))
         (fibr (fibr1 fib))
         (incl-1 (incl-11 fib))
         (tot (trgt incl))
         (base (trgt fibr))
         (base-kfll (kfll base))
         (base-bspn (bspn base))
         (base-face (face base))
         (bspn (bspn tot))
         (tot-face (face tot))
         (tot-kfll (kfll tot)))
  (flet ((rslt (absm)
               (declare 
                        (type gnrt absm))
               (let ((j (funcall (f (funcall (efhmt1 base) dmns)) (? fibr dmns absm)))
                     (bgroup (gr (funcall (efhmt1 base) dmns))))
                 (if (or (not j) (cmbn-zerop bgroup j))
                     (funcall (kan-fibr-retraction-aux-intr fib dmns) absm)
                   (let* ((absm2 (funcall (kan-fibr-section-intr fib dmns) (? fibr dmns absm) ))
                         (z (funcall (ksmst-sum tot-kfll tot-face bspn) dmns absm (funcall (ksmst-inv tot-kfll tot-face bspn) dmns absm2))))
                     (funcall (kan-fibr-retraction-aux-intr fib dmns) z ))
                    ))))
    #'rslt)))



#|

(cat-init)

(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 0
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))


(setf dmns 1)

(setf sctn (kan-fibr-section-intr fib 1))
(setf rtrct (kan-fibr-retraction-intr fib 1))
(setf incl (kan-fibr-sg-incl fib 1))
(setf proj (kan-fibr-sg-proj fib 1))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))



(setf s (funcall (g e) '(1 0)))
(funcall (f e) s)


(setf s2 (funcall (g e) '(0 1)))
(funcall (f e) s2)





(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))


(setf dmns 1)

(setf sctn (kan-fibr-section-intr fib 1))
(setf rtrct (kan-fibr-retraction-intr fib 1))
(setf incl (kan-fibr-sg-incl fib 1))
(setf proj (kan-fibr-sg-proj fib 1))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))



(setf s (funcall (g e) '(1)))
(funcall (f e) s)






(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 3
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))




(setf dmns 1)

(setf sctn (kan-fibr-section-intr fib 1))
(setf rtrct (kan-fibr-retraction-intr fib 1))
(setf incl (kan-fibr-sg-incl fib 1))
(setf proj (kan-fibr-sg-proj fib 1))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))


(setf s (funcall (g e) '(1 0)))
(funcall (f e) s)


(setf s2 (funcall (g e) '(0 1)))
(funcall (f e) s2)











(setf a (sorc incl))
(setf b (trgt incl))
(setf c (trgt proj))
(setf mtrxa (mtrx (gr a)))
(setf na (nlig mtrxa))
(setf mtrxc (mtrx (gr c)))
(setf nc (nlig mtrxc))




(defun gaux (el)
            (declare (type list el))
            (let* ((ela (subseq el 0 na))
                   (elc (subseq el na))
                   (rslt (nullel b)))
              (dotimes (i (length ela))
                (if (> (nth i ela) 0)      
                  (dotimes (j (nth i ela) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (intr incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i)))))))))
                  (dotimes (j (- (nth i ela)) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (inv1 b) (funcall (intr incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i)))))))))
                    )))
              (dotimes (i (length elc))
                (if (> (nth i elc) 0)
                    (dotimes (j (nth i elc) )
                      (setf rslt (funcall (cmps1 b) rslt 
                                          (funcall sctn (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i)))))))))
                  (dotimes (j (- (nth i elc)) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (inv1 b) (funcall (intr incl) (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i)))))))))
                    )
                  
                  ))
              rslt))


(setf nrow (nlig mtrxa))
(setf ncol (ncol mtrxc))
(setf vctr-list nil)


(setf ela (subseq el 0 na))
(setf elc (subseq el na))
(setf rslt (nullel b))




(dotimes (i (length ela))
                (dotimes (j (nth i ela))
                  (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (intr1 incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i))))))))))
(dotimes (i (length elc))
                (dotimes (j (nth i elc))
                  (setf rslt (funcall (cmps1 b) rslt 
                                     (funcall sctn (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i))))))))))
;;; est mal esto



(setf new-mtrx (Gnrt-List-to-Mtrx vctr-list))
(setf zero-mtrx (creer-matrice (nlig mtrxc) (ncol mtrxa)))
(setf aux (mtrx-conc2 (mtrx-conc mtrxa new-mtrx) (mtrx-conc zero-mtrx mtrxc)))
(setf cn (canonical-representation aux))
(setf mtrx (first cn))
(setf inc2 (second cn))
(setf proj2 (third cn))
(setf gr (build-fngn-abgroup :mtrx mtrx :orgn `(Central extension2 of ,incl ,proj ,sctn ,rtrct)))



(setf ela (subseq el 0 na))
(setf elc (subseq el na))
(setf rslt (nullel b))

(setf i 0)
(setf j 0)
(dotimes (i (length ela))
                (dotimes (j (nth i ela))
                  (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (intr incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i))))))))))
              (dotimes (i (length elc))
                (dotimes (j (nth i elc))
                  (setf rslt (funcall (cmps1 b) rslt 
                                     (funcall sctn (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i))))))))))
  rslt)






(setf kffll (kffll fib))
(setf incl (incl1 fib))
(setf proj (fibr1 fib))
(setf incl-1 (incl-11 fib))
(setf tot (trgt incl))
(setf base (trgt fibr))
(setf base-kfll (kfll base))
(setf base-bspn (bspn base))
(setf base-face (face base))
(setf bspn (bspn tot))
(setf tot-face (face tot))
(setf tot-kfll (kfll tot))
(setf absm s)

(setf j (funcall (f (funcall (efhmt1 base) dmns)) (? proj dmns absm)))
(setf bgroup (gr (funcall (efhmt1 base) dmns)))
                   
                   
(setf absm2 (funcall (kan-fibr-section-intr fib dmns) (? proj dmns absm) ))


                         (z (funcall (ksmst-sum tot-kfll tot-face bspn) dmns absm (funcall (ksmst-inv tot-kfll tot-face bspn) dmns absm2))))
                     (funcall (kan-fibr-retraction-aux-intr fib dmns) z ))
))







(cat-init)
(setf x1 (k-zp 0 3))
(setf chmlcl1 (chml-clss x1 3))
(setf chmlcl (n-mrph 3 chmlcl1))
(setf twop (z-whitehead x1 chmlcl))

(setf fib (twop-kanfibration twop))
(setf dmns 3)

(setf sctn (kan-fibr-section-intr fib 3))
(setf rtrct (kan-fibr-retraction-intr fib 3))
(setf incl (kan-fibr-sg-incl fib 3))
(setf proj (kan-fibr-sg-proj fib 3))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))


(setf sctn (kan-fibr-section-intr fib 2))
(setf rtrct (kan-fibr-retraction-intr fib 2))
(setf incl (kan-fibr-sg-incl fib 2))
(setf proj (kan-fibr-sg-proj fib 2))





(setf a (sorc incl) b (trgt incl) c (trgt proj))
(divisors (gr a))
(divisors (gr c))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))

(setf s (funcall (g e) '(1)))
(funcall (f e) s) 


(setf sctn (kan-fibr-section-intr fib 1))
(setf rtrct (kan-fibr-retraction-intr fib 1))
(setf incl (kan-fibr-sg-incl fib 1))
(setf proj (kan-fibr-sg-proj fib 1))

(setf e (esg-central-extension incl proj sctn rtrct))
(divisors (gr e))





|#

(defun esg-mrph-element-preimage (mrph absm)
  (let* ((mtrx0 (mtrx0 mrph))
         (mtrx1 (mtrx1 mrph))
         (sorc (gr (sorc mrph)))
         (trgt (gr (trgt mrph)))
         (f (f (trgt mrph)))
         (g (g (sorc mrph)))
         (grmrph (BUILD-fngn-abgroup-mrph :sorc sorc :trgt trgt :mtrx0 mtrx0 :mtrx1 mtrx1 :orgn `(Group morphism of ,mrph)))
         (el (mrph-element-preimage grmrph (funcall f absm)))
         )
    (funcall g el)))
         


(defun kfbr-tot-efhmt-h-2 (fib dmns)
  (flet ((rslt (absm)
               (declare (type fixnum dmns)
                        (type absm absm))
               (let* ((kffll (kffll fib))
                      (incl (incl1 fib))
                      (proj (fibr1 fib))
                      (base (trgt proj))
                      (fiber (sorc incl))
                      (tot (trgt incl))
                      (bspn (bspn tot))
                      (tot-face (face tot))
                      (incl-1 (incl-11 fib))
                      (befhmt (efhmt1 base))
                      (fefhmt (efhmt1 fiber))
                      ;;
                      (bf (f (funcall befhmt dmns)))
                      (bg (g (funcall befhmt dmns)))
                      (bh (h (funcall befhmt dmns)))
                      (ff (f (funcall fefhmt dmns)))
                      (fg (g (funcall fefhmt dmns)))
                      (fh (h (funcall fefhmt dmns)))
                      (bgr (gr (funcall befhmt dmns)))
                      (tot-kfll (kfll tot))
                      (base-kfll (kfll base))
                      (base-bspn (bspn base))
                      (base-face (face base))
                      (fiber-kfll (kfll fiber))
                      (fiber-bspn (bspn fiber))
                      (fiber-face (face fiber))
                      ;;(section (kan-fibr-section kffll incl incl-1 bspn tot-face bg fh tot-kfll))
                      (retraction (kan-fibr-retraction proj base bf bh ff base-kfll base-bspn tot-face kffll
                                                       incl incl-1 bspn bg fh tot-kfll base-face bgr))
                      (sum (ksmst-sum tot-kfll tot-face bspn))
                      (fsum (ksmst-sum fiber-kfll fiber-face fiber-bspn))
                      (inv (ksmst-inv tot-kfll tot-face bspn))
                      (finv (ksmst-inv fiber-kfll fiber-face fiber-bspn))
                      (cnmrph-dmns+1 (kan-fibr-cnmrph fib (1+ dmns)))
                      (x 
                       (let ((a (funcall bh (? proj dmns absm)))
                               (hat nil)             
                               (m (mask (1+ dmns))))
                           (dotimes (i dmns)
                             (push (absm m base-bspn) hat))
                           (push a hat)
                           (push (absm m base-bspn) hat)
                           (let* ((w (funcall base-kfll (+ 2 dmns) (+ 2 dmns) hat))
                                  (b (a-face4 base-face (+ 2 dmns) (+ 2 dmns) w))
                                  (hat2 nil))
                             (dotimes (i dmns)
                               (push (absm m bspn) hat2))
                             (push absm hat2)
                             (funcall kffll 0 (1+ dmns) hat2 b))))
                      (del0x (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) x)))
                      (v (esg-mrph-element-preimage cnmrph-dmns+1 del0x))
                      
                      
                      
                      (w 
                       (let ((hat nil)
                             (m (mask (1+ dmns))))
                         (dotimes (i (1+ dmns))
                           (push (absm m bspn) hat))
                         (funcall kffll 0 (1+ dmns) hat v)))
                      (del0w
                           (?3 incl-1 dmns (a-face4 tot-face 0 (1+ dmns) w)))
                      
                      (del0w-del0x (funcall fsum dmns del0w (funcall finv dmns del0x)))
                      (a (funcall fh del0w-del0x))
                      (s (funcall (2elements-homotopy fiber-kfll fiber-face fiber-bspn) dmns del0x del0w a)))

                      
                      (let ((hat nil)             
                            (m (mask (1+ dmns))))
                        (push x hat)
                        (push w hat)
                        (dotimes (i (1- dmns))
                          (push (absm m bspn) hat))
                        (push (?3 incl (1+ dmns) s) hat)
                        (let ((y (funcall tot-kfll 1 (+ 2 dmns) hat)))
                          (a-face4 tot-face 1 (+ 2 dmns) y)))
                        
                 )))
               #'rslt))


               

(defun kfbr-tot-efhmt (fib)
  (flet ((rslt (dmns)
               (let* ((sctn (kan-fibr-section-intr fib dmns))
                      (rtrct (kan-fibr-retraction-intr fib dmns))
                      (incl (kan-fibr-sg-incl fib dmns))
                      (proj (kan-fibr-sg-proj fib dmns))
                      (ext (esg-central-extension incl proj sctn rtrct))
                      (new-h (kfbr-tot-efhmt-h-2 fib dmns)))
                 (setf (slot-value ext 'h) new-h )
                 (setf (slot-value ext 'orgn) `(Effective homotopy of the total space of ,fib in dimension ,dmns))
                 ext)))
    #'rslt))
                 
  
  
  








