;; SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS
;; SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS
;; SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS SETOID-GROUPS


(DEFTYPE SETOID-ELMS () '(or list (eql :locally-effective)))

(defun extract-term-0 (mtrx i j)
  (let ((aij (extract-term mtrx i j)))
    (if aij aij 0)))



(DEFCLASS SETOID-GROUP ()
  ((elms :type setoid-elms :initarg elms :reader elms)
   (cmps :type function :initarg :cmps :reader cmps1)
   (nullel :type gnrt :initarg :nullel :reader nullel)
   (inv :type function :initarg :inv :reader inv1)
   (idnm :type fixnum :initform (incf *idnm-counter*) :reader idnm)
   (orgn :type list :initarg :orgn :reader orgn)   
   ))

(DEFCLASS EFFECTIVE-SETOID-GROUP (SETOID-GROUP)
  ((gr :type fngn-abgroup :initarg :gr :reader gr)
   (f :type function :initarg :f :reader f1)
   (g :type function :initarg :g :reader g1)
   (h :type function :initarg :h :reader h1)
   ))


(DEFMETHOD INITIALIZE-INSTANCE :after ((sg SETOID-GROUP) &rest rest)
  (set (intern (format nil "K~D" (idnm sg))) sg))


(DEFVAR *SETOID-GROUP-list*)
(SETF *SETOID-GROUP-list* +empty-list+)
(PUSHNEW '*SETOID-GROUP-list* *list-list*)


(DEFMETHOD PRINT-OBJECT ((sg SETOID-GROUP) stream)
   (the SETOID-GROUP
     (progn
      (format stream "[K~D SETOID-GROUP" (idnm sg))
      sg)))


(DEFUN SETOID-GROUP (idnm)
   (declare (type fixnum idnm))
   (the (or SETOID-GROUP null)
     (find idnm *SETOID-GROUP-list* :key #'idnm)))


(defun build-sg (&key elms cmps nullel inv orgn)
   (declare 
     (type setoid-elms elms)
    (type function cmps)
     (type function inv)
     (type gnrt nullel)
     (list orgn))
   (the SETOID-GROUP
     (progn
      (let ((already (find orgn *SETOID-GROUP-list* :test #'equal :key #'orgn)))
         (declare (type (or group null) already))
         (when already
            (return-from build-sg already)))
      (unless elms
         (setf elms :locally-effective))
      (let ((sg (make-instance 'setoid-group
                     :elms elms
                     :cmps cmps
                     :inv inv
                     :nullel nullel
                     :orgn orgn)))
         (declare (type setoid-group sg))   
         (push sg *setoid-group-list*)
        sg))))





(DEFVAR *EFFECTIVE-SETOID-GROUP-list*)
(SETF *EFFECTIVE-SETOID-GROUP-list* +empty-list+)
(PUSHNEW '*EFFECTIVE-SETOID-GROUP-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((esg EFFECTIVE-SETOID-GROUP) stream)
   (the EFFECTIVE-SETOID-GROUP
     (progn
      (format stream "[K~D EFFECTIVE-SETOID-GROUP]" (idnm esg))
      esg)))

(DEFUN EFFECTIVE-SETOID-GROUP (idnm)
   (declare (type fixnum idnm))
   (the (or EFFECTIVE-SETOID-GROUP null)
     (find idnm *EFFECTIVE-SETOID-GROUP-list* :key #'idnm)))

(defun build-esg (&key elms cmps nullel inv gr f g h orgn)
  (declare 
     (type setoid-elms elms)
    (type function cmps)
     (type function inv)
   (type gnrt nullel)
   (type fngn-abgroup gr)
   (type function f g h)
   (list orgn))
  (let ((already (find orgn *EFFECTIVE-SETOID-GROUP-list* :test #'equal :key #'orgn)))
    (declare (type (or EFFECTIVE-SETOID-GROUP null) already))
    (when already
      (return-from build-esg already)))
  
  (let ((rslt (build-sg
               :elms elms :cmps cmps :nullel nullel :inv inv
               :orgn orgn)))
     (declare (type SETOID-GROUP rslt))
     (change-class rslt 'EFFECTIVE-SETOID-GROUP)
    (setf (slot-value rslt 'gr) gr (slot-value rslt 'f) f (slot-value rslt 'g) g (slot-value rslt 'h) h)
    (push rslt *setoid-group-list*)
    (push rslt *EFFECTIVE-SETOID-GROUP-list*)
    rslt))

(DEFMETHOD SLOT-UNBOUND (class (esg EFFECTIVE-SETOID-GROUP) (slot-name (eql 'elms)))
   (declare (ignore class))
  (setf (slot-value esg 'elms) :locally-effective))

(defun sg-to-esg (m gr f g h)
  (change-class m 'EFFECTIVE-SETOID-GROUP)
    (setf (slot-value m 'gr) gr (slot-value m 'f) f (slot-value m 'g) g (slot-value m 'h) h)
  (push m *EFFECTIVE-SETOID-GROUP-list*)
  m)


(DEFCLASS SG-MRPH ()
  ;; SOuRCe
  ((sorc :type setoid-group :initarg :sorc :reader sorc)
   ;; TaRGeT
   (trgt :type setoid-group :initarg :trgt :reader trgt)
   ;; INTeRnal function
   (intr :type function :initarg :intr :reader intr)
   ;; IDentification NuMber      
   (idnm :type fixnum :initform (incf *idnm-counter*) :reader idnm)      
   ;; ORiGiN      
   (orgn :type list :initarg :orgn :reader orgn))
  )


(DEFMETHOD INITIALIZE-INSTANCE :after ((SG-MRPH SG-MRPH) &rest rest)
  (set (intern (format nil "K~D" (idnm SG-MRPH))) SG-MRPH))

(DEFVAR *SG-MRPH-list*)
(SETF *SG-MRPH-list* +empty-list+)
(PUSHNEW '*SG-MRPH-list* *list-list*)


(DEFMETHOD PRINT-OBJECT ((SG-MRPH SG-MRPH) stream)
   (the SG-MRPH
     (progn
      (format stream "[K~D Setoid-group-morphism" (idnm SG-MRPH))
       SG-MRPH)))

(DEFUN SG-MRPH (idnm)
   (declare (type fixnum idnm))
   (the (or SG-MRPH null)
     (find idnm *SG-MRPH-list* :key #'idnm)))


(DEFUN BUILD-sg-mrph (&key sorc trgt intr orgn)
   (declare
      (type setoid-group sorc trgt)
      (type function intr)
      (list orgn))
   (the sg-mrph
     (progn
         (let ((already (find orgn *sg-mrph-list* :test #'equal :key #'orgn)))
            (declare (type (or sg-mrph null) already))
            (when already
               (return-from build-sg-mrph already)))
         (let ((mrph (make-instance 'sg-mrph
                       :sorc sorc 
                       :trgt trgt 
                       :intr intr
                       :orgn orgn)))
            (declare (type sg-mrph mrph))
            (push mrph *sg-mrph-list*)
           mrph))))

(DEFCLASS ESG-MRPH (SG-MRPH)
    ;; MaTRiX0      
     ((mtrx0 :type matrice :initarg :mtrx0 :reader mtrx0) 
     ;; MaTRiX1      
     (mtrx1 :type matrice :initarg :mtrx1 :reader mtrx1)    
     ;; IDentification NuMber      
      ))


(DEFVAR *ESG-MRPH-list*)
(SETF *ESG-MRPH-list* +empty-list+)
(PUSHNEW '*ESG-MRPH-list* *list-list*)

(DEFMETHOD PRINT-OBJECT ((mrph ESG-MRPH) stream)
   (the ESG-MRPH
     (progn
      (format stream "[K~D Effective-Magma-Group-Morphism]" (idnm mrph))
      mrph)))

(DEFUN ESG-MRPH (idnm)
   (declare (type fixnum idnm))
   (the (or ESG-MRPH null)
     (find idnm *ESG-MRPH-list* :key #'idnm)))


(defun esg-intr-mtrxs (sorcesg trgtesg intr)
  (declare 
   (type esg sorcesg trgtesg)
   (type function intr)
   )
  (let* ((sg (g sorcesg))
         (tf (f trgtesg))
         (smtrx (mtrx (gr sorcesg)))
         (tmtrx (mtrx (gr trgtesg)))         
         (mtrx0-gnrt-list nil)
         (mtrx1-gnrt-list nil))
    (dotimes (i (nlig smtrx))
      (let* ((gnrti (nconc (zero-list i) (list 1) (zero-list (1- (- (nlig smtrx) i)))))
             (ggnrti (funcall sg gnrti)))
          (let ((imgi
                 (funcall tf (funcall intr ggnrti))))
            (push imgi mtrx0-gnrt-list))))
    (setf mtrx0-gnrt-list (nreverse mtrx0-gnrt-list))
    (let ((mtrx0 (if (= 0 (nlig tmtrx))
                     (creer-matrice 0 (nlig smtrx))
                   (if mtrx0-gnrt-list (Gnrt-List-to-Mtrx mtrx0-gnrt-list)
                     (creer-matrice (nlig tmtrx) 0 )))
           ))
      (dotimes (i (ncol smtrx)) 
        (let* ((iimgi (column-j (mtrx-prdc mtrx0 smtrx) (1+ i)))
               (imgi 
                (mapcar #'(lambda (j)
                            (let* ((aj (nth j iimgi))
                                   (dj (extract-term tmtrx (1+ j) (1+ j)))
                                   )
                              (if (= 0 dj) aj
                                (/ aj dj))))
                              (<a-b< 0 (nlig tmtrx)))))
          (push imgi mtrx1-gnrt-list)))
      (setf mtrx1-gnrt-list (nreverse mtrx1-gnrt-list))
      (let ((mtrx1 (if (= 0 (ncol tmtrx))
                     (creer-matrice 0 (ncol smtrx))
                     (if mtrx1-gnrt-list (Gnrt-List-to-Mtrx mtrx1-gnrt-list)
                   (creer-matrice (ncol tmtrx) 0 )))))
        (list mtrx0 mtrx1)))))


(defun build-ESG-MRPH (&key sorc trgt intr mtrx0 mtrx1 orgn)
  (declare
      (type effective-setoid-group sorc trgt)
   (type function intr)
   (type matrice mtrx0 mtrx1)
   (list orgn))
  (let ((orgn (if (not orgn)
                  `(ESG-mrph ,sorc ,trgt ,intr ,mtrx0 ,mtrx1)
                orgn)))
  (let ((already (find orgn *ESG-MRPH-list* :test #'equal :key #'orgn)))
    (declare (type (or ESG-MRPH null) already))
    (when already
      (return-from build-ESG-MRPH already)))  
  (let ((rslt (build-SG-MRPH
		:sorc sorc 
                       :trgt trgt 
                       :intr intr
                       :orgn orgn)))
     (declare (type sg-mrph rslt))
    (change-class rslt 'ESG-MRPH)
    (unless mtrx0
      (let* ((mtrxs (esg-intr-mtrxs sorc trgt intr)))
        (setf mtrx0 (first mtrxs))
        (setf mtrx1 (second mtrxs))))
    (setf (slot-value rslt 'mtrx0) mtrx0 (slot-value rslt 'mtrx1) mtrx1)
    (push rslt *SG-MRPH-list*)
    (push rslt *ESG-MRPH-list*)
    rslt)))



(defun esg-mrph-cokernel (mrph)
  (let* ((sorc (sorc mrph))
        (trgt (trgt mrph))
        (mtrx0 (mtrx0 mrph))
         (mtrx1 (mtrx1 mrph))
         (grsorc (gr sorc))
         (grtrgt (gr trgt))
         (f (f trgt))
         (g (g trgt))
         (h (h trgt))
         (grmrph (BUILD-fngn-abgroup-mrph :sorc grsorc :trgt grtrgt :mtrx0 mtrx0 :mtrx1 mtrx1 :orgn `(Group-morphism2 of ,mrph) ))
         (cokernel2 (cokernel3 grmrph))
         (proj (second cokernel2))
         (inc (third cokernel2))
         (gr (first cokernel2)))
    (build-esg 
     :elms (elms trgt)
     :cmps (cmps1 trgt)
     :inv (inv1 trgt)
     :nullel (nullel trgt)
     :gr gr
     :f #'(lambda (gnrt) 
            (column-j (mtrx-prdc proj (Gnrt-List-to-Mtrx (list (funcall f gnrt)))) 1))
     :g #'(lambda (el)
            (funcall g (column-j (mtrx-prdc inc (Gnrt-List-to-Mtrx (list el))) 1)))
     :h h
     :orgn   `(esg-mrph-cokernel ,mrph))))



(defun esg-mrph-kernel (mrph)
  (let* ((sorc (sorc mrph))
        (trgt (trgt mrph))
        (mtrx0 (mtrx0 mrph))
         (mtrx1 (mtrx1 mrph))
         (grsorc (gr sorc))
         (grtrgt (gr trgt))
         (f (f sorc))
         (g (g sorc))
         (h (h sorc))
         (grmrph (BUILD-fngn-abgroup-mrph :sorc grsorc :trgt grtrgt :mtrx0 mtrx0 :mtrx1 mtrx1 :orgn `(Group-morphism of ,mrph) ))
         (kernel2 (kernel3 grmrph))
         (inc (second kernel2))
         (proj (third kernel2))
         (gr (first kernel2)))
    (build-esg 
     :elms (elms sorc)
     :cmps (cmps1 sorc)
     :inv (inv1 sorc)
     :nullel (nullel sorc)
     :gr gr
     :f #'(lambda (gnrt) 
            (if (> (nlig (mtrx gr)) 0) 
                (column-j (mtrx-prdc proj (Gnrt-List-to-Mtrx (list (funcall f gnrt)))) 1)
            nil))
     :g #'(lambda (el)
            (funcall g (column-j (mtrx-prdc inc (Gnrt-List-to-Mtrx (list el))) 1)))
     :h h
     :orgn   `(esg-mrph-kernel ,mrph))))



(defmethod mrph-kernel ((mrph ESG-MRPH))
  (esg-mrph-kernel mrph))

(defmethod mrph-cokernel ((mrph ESG-MRPH))
  (esg-mrph-cokernel mrph))



#|
(cat-init)
(setf gm1 (creer-matrice 1 1))
(inserer-terme (baselig gm1 1) (basecol gm1 1) 2)
(setf gm2 (creer-matrice 1 1))
(inserer-terme (baselig gm2 1) (basecol gm2 1) 4)
(setf m0 (creer-matrice 1 1))
(inserer-terme (baselig m0 1) (basecol m0 1) 2)
(setf m1 (creer-matrice 1 1))
(inserer-terme (baselig m1 1) (basecol m1 1) 1)
(setf gr1 (build-fngn-abgroup :mtrx gm1 :orgn '(z2)))
(setf gr2 (build-fngn-abgroup :mtrx gm2 :orgn '(z4)))
(setf kgr11 (k-g gr1 1))
(setf kgr21 (k-g gr2 1))
(setf esg1 (funcall (efhmt1 kgr11) 1))
(setf esg2 (funcall (efhmt1 kgr21) 1))
(setf intr #'(lambda (absm)
                               (with-absm (dgop gnrt) absm
                                 (if (= 0 dgop) (absm 0 (list (list 2)))
                                   absm)))
)
(setf mrph (build-esg-mrph :sorc esg1 :trgt esg2 :mtrx0 m0 :mtrx1 m1 :intr 
                           intr
                                 
                           :orgn '(group-morphism)))
(setf kr (esg-mrph-kernel mrph))
(divisors (gr kr))
(setf ck (esg-mrph-cokernel mrph))
(divisors (gr ck))


(esg-intr-mtrxs esg1 esg2 intr)

(setf mrph2 (build-esg-mrph :sorc esg1 :trgt esg2  :intr 
                           intr
                                 
                           :orgn '(group-morphism2)))
(setf kr (esg-mrph-kernel mrph2))
(divisors (gr kr))
(setf ck (esg-mrph-cokernel mrph2))
(divisors (gr ck))



|#
               
    

(defun list-sign-change (l)
  (declare (type list l))
  (mapcar #'(lambda (n)
              (- n))
    l))


(defun apply-mtrx-to-element (mtrx el)
  (declare (type matrice mtrx)
           (type list el))
  (column-j  (mtrx-prdc mtrx (Gnrt-List-to-Mtrx (list el))) 1)) 


   
(defun esg-central-extension (incl proj sctn rtrct)
  (declare 
   (type sg-mrph incl proj)
   (type function sctn rtrct))
  (let* ((a (sorc incl))
         (b (trgt incl))
         (c (trgt proj))
         (mtrxa (mtrx (gr a)))
         (na (nlig mtrxa))
         (mtrxc (mtrx (gr c)))
         (nc (nlig mtrxc)))
    (declare 
     (type esg a c)
     (type sg b))
    (flet 
        ((gaux (el)
            (declare (type list el))
            (let* ((ela (subseq el 0 na))
                   (elc (subseq el na))
                   (rslt (nullel b)))
              (dotimes (i (length ela))
                (if (> (nth i ela) 0)      
                  (dotimes (j (nth i ela) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (intr incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i)))))))))
                  (dotimes (j (- (nth i ela)) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (inv1 b) (funcall (intr incl) (funcall (g a) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- na i)))))))))
                    )))
              (dotimes (i (length elc))
                (if (> (nth i elc) 0)
                    (dotimes (j (nth i elc) )
                      (setf rslt (funcall (cmps1 b) rslt 
                                          (funcall sctn (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i)))))))))
                  (dotimes (j (- (nth i elc)) )
                    (setf rslt (funcall (cmps1 b) rslt 
                                        (funcall (inv1 b) (funcall sctn (funcall (g c) (nconc (zero-list (1- i)) (list 1) (zero-list (1- (- nc i)))))))))
                    )
                  
                  ))
              rslt)))
      
      (let* ((nrow (nlig mtrxa))
             (ncol (ncol mtrxc))
             (vctr-list nil)
             )
        (if (= 0 nrow)
            (let ((mtrx (creer-matrice (nlig mtrxc) (nlig mtrxc))))
              (dotimes (i (nlig mtrxc)
                          (inserer-terme (baselig mtrx i) (basecol mtrx i) 1)))
              (flet 
                  ((f (s)
                      (declare (type gnrt s))
                      (funcall (f c) (funcall (intr proj) s)))
                      
                      
                   (g (el)
                      ;;(declare (type list el))
                    (funcall sctn  (funcall (g c) el)))
                      
                   (h (s)
                    (declare (type gnrt s))
                      (funcall (h c) (funcall (intr proj) s))))
                (sg-to-esg b  
              
               (gr c) #'f #'g #'h)))
          (progn
            
            (dotimes (i ncol)
              (let* ((mi (column-j mtrxc (1+ i)))
                     (gi (nconc (zero-list na) mi))
                     (rslt (funcall (f a) (funcall rtrct (gaux gi)))))
                (push (list-sign-change rslt) vctr-list)))
          (setf vctr-list (nreverse vctr-list))  
            (let* ((new-mtrx (Gnrt-List-to-Mtrx vctr-list))
                   (zero-mtrx (creer-matrice (nlig mtrxc) (ncol mtrxa)))
                   (aux (mtrx-conc2 (mtrx-conc mtrxa new-mtrx) (mtrx-conc zero-mtrx mtrxc)))
                   (cn (canonical-representation aux))
                   (mtrx (first cn))
                   (inc2 (second cn))
                   (proj2 (third cn))
                   (gr (build-fngn-abgroup :mtrx mtrx :orgn `(Central extension2 of ,incl ,proj ,sctn ,rtrct))))
              
              (flet 
                  ((f (s)
                      (declare (type gnrt s))
                      (apply-mtrx-to-element proj2 
                                             (nconc
                                              (funcall (f a) (funcall rtrct s))
                                              (funcall (f c) (funcall (intr proj) s)))))
                   (g (el)
                      ;;(declare (type list el))
                    (gaux (apply-mtrx-to-element inc2 el)))
                      
                   (h (s)
                    (declare (type gnrt s))
                    (nconc
                     (funcall (h a) (funcall rtrct s))
                     (funcall (h c) (funcall (intr proj) s)))))
                (sg-to-esg b  
              
               gr #'f #'g #'h)))))))))




#|

(cat-init)
(setf a (cyclic-group 6))


(defun cocycle-aux (c1 c2)
  (let* ((g1 (mod c1 6))
         (g2 (mod c2 6))
         (rslt
          (if (< (+ g1 g2) 6) 0
            (if (= 6 (+ g1 g2)) 1
              (let ((g1-1 (1- g1)))
                (+ (cocycle-aux g1-1 g2) (- (cocycle-aux 1 (+ g1 g2 -1)) (cocycle-aux 1 g1-1))))
              ))))
    rslt))

(setf cocycle #'(lambda (c1 c2)
                  (list (cocycle-aux (first c1) (first c2)))))





(setf ka1 (k-g-1 a))
(setf twop (fngnabgr-cocycle-fibration a a cocycle))


(setf fib (twop-kanfibration twop))

(setf incl (incl1 fib) proj (fibr1 fib) incl-1 (incl-11 fib))
(setf e (trgt incl) b (sorc incl) f (trgt proj))
(setf bspn (bspn e))

(setf sctn (kan-fibr-section (kffll fib) incl incl-1 bspn  (face e) (bg fh tot-kfll)

      

|#

    
    
    

  







